-- EVENT HANDLER --
MyEventHandler = {} -- Event Table
world.addEventHandler(MyEventHandler) 
function MyEventHandler:onEvent(event) 
	-- 	which events don not have a unit associated with them or player is dead
	-- if Debugging == true then printDebug ("EventHandler" , "An Event has happened "  .. event.id , 10 ) end
	if event.id == world.event.S_EVENT_MISSION_END or event.id == world.event.S_EVENT_INVALID or event.id == 2 or event.id == 17  or event.id == 22 or event.id > 25 or PlayerAlive == false then
		--if Debugging == true then printDebug ("EventHandler" , "The mission is ending or is invalid: "  .. event.id , 10 ) end
		if event.id == world.event.S_EVENT_MISSION_END then
			env.setErrorMessageBoxEnabled(false) -- THE MISSION HAS ENDED SUPRESS ALL ERRORS
			--if Debugging == true then printDebug ("EventHandler" , "The mission is ending or is invalid: "  .. event.id , 10 ) end
		end

		if event.id > 25 then
			-- if Debugging == true then printDebug ("EventHandler" , "An unknown event occured id: "  .. event.id , 10 ) end
		end
		if event.id == world.event.S_EVENT_HIT then
			--if Debugging == true then printDebug ("EventHandler" , "An Event type hit occured :"  .. event.id , 10 ) end
		end
		if event.id == world.event.S_EVENT_DETAILED_FAILURE then
			-- if Debugging == true then printDebug ("EventHandler" , "An Event Detailed failure occured :"  .. event.id , 10 ) end
		end
		
	elseif event.id == 21 and event.initiator == nil then
		-- if Debugging == true then printDebug ("EventHandler" , "Clicking around on the role page" , 10 ) end
	else  -- ITS AN unit level event
		-- INIT ALL THE LOCAL VARIABLES

		local unit = event.initiator 
		--if Debugging == true then printDebug ("EventHandler" ,  Object.getCategory(unit) , 10 ) end 
		local myWhichUnit = "" 
		if event.id ~= world.event.S_EVENT_BASE_CAPTURED then myWhichUnit = unit:getName() end
		local myUnitID
		local myGroupName = ""
		local myGroupObj = {} 
		local myGroupID = ""
		local myAircraftType =""
		-- if Debugging == true then printDebug ("EventHandler" , "Event for: " .. myWhichUnit , 10 ) end
		-- is it scenery objects or unit
		--if ( tonumber(myWhichUnit) ~= nil ) or myWhichUnit:find("Static ")  then -- ITS A scenery objects seem tobe all numbers for unit names PROB A HACK HERE
		local myObjectCat = Object.getCategory(unit) 
		if  myObjectCat == 3 or myObjectCat == 4 or myObjectCat == 5 then -- ITS A static scenery objects or base
			 myGroupName = "Scenery Object"
			 myGroupID = "nul"
			 myAircraftType = "Static" 
		elseif event.id ~= world.event.S_EVENT_BASE_CAPTURED then -- ITS A UNIT
				myGroupObj = Unit.getGroup(unit)
				myGroupName = Group.getName(myGroupObj)
				myGroupID = Group.getID(myGroupObj )	
				myAircraftType = unit:getTypeName()
		end
		
		--if Debugging == true then printDebug ("EventHandler" , "Event For Group: " .. myGroupName .. " Group Number: " ..  myGroupID .. " Unit:" .. myWhichUnit .. " Type: " .. myAircraftType , 10 ) end

		--- MISSION START ---
		if event.id == world.event.S_EVENT_MISSION_START then
			--if Debugging == true then printDebug ("EventHandler" , "The mission is starting"   , 10 ) end
		end
		--- PLAYER ENTERED UNIT ---
		if event.id == world.event.S_EVENT_PLAYER_ENTER_UNIT then
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " has entered a unit "  ..event.id  , 10 ) end 
			-- insertPlayerIntoMission( { unit=myWhichUnit } )
		end
		--- PLAYER LEFT UNIT ---
		if event.id == world.event.S_EVENT_PLAYER_LEAVE_UNIT then

			if gPlayerGroups[myGroupName] ~= nil then 
				-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " has left a unit "  ..event.id  , 10 ) end 
				-- removePlayerFromSquad ( { unit=myWhichUnit } )
				removePlayerFromMission ( { unit=myWhichUnit } )
			end 
		
		end
		--- BIRTH ---
		if event.id == world.event.S_EVENT_BIRTH then 
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " is birthing "  ..myGroupID  , 10 ) end 
			local mySide = Unit.getCoalition(unit)
			local myPlayers = coalition.getPlayers(mySide)
			for key , value in pairs(myPlayers) do
				local myUnit = Unit.getName(value)
				if myUnit == myWhichUnit then insertPlayerIntoMission( { unit=myWhichUnit } ) end 
			end 


		end
		--- ENGINE START ---
		if event.id == world.event.S_EVENT_ENGINE_STARTUP then 
		   -- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " is starting engines"  ..event.id  , 10 ) end 
		end	
		--- ENGINE STOP ---
		if event.id == world.event.S_EVENT_ENGINE_SHUTDOWN then
			shutdownEvent ( { unit=myWhichUnit , group=myGroupName } )
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " is shutting down"   , 10 ) end 			
		end
		--- TAKING OFF ---	
		if event.id == world.event.S_EVENT_TAKEOFF then  
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " is taking off"   , 10 ) end 
		end
		--- LANDING ---
		if event.id == world.event.S_EVENT_LAND then
			landingEvent ( { unit=myWhichUnit , group=myGroupName } )
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " is landing"   , 10 ) end 
		end  
		--- EJECT ---
		if event.id == world.event.S_EVENT_EJECTION then
			if gPlayers[myWhichUnit] ~= nil then
				-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " has ejected"  ..event.id  , 10 ) end 
				  removePlayerFromMission ( { unit=myWhichUnit } )
			else --its an AI
				removeTarget ( { unit=myWhichUnit , group=myGroupName } )	
			end 
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " is ejecting"   , 10 ) end  	
		end	
		--- CRASH ---
		if event.id == world.event.S_EVENT_CRASH then
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " has crashed"   , 10 ) end
			if gPlayers[myWhichUnit] ~= nil then
					-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " has crashed "  ..event.id  , 10 ) end 
				  removePlayerFromMission ( { unit=myWhichUnit } )
			else --its an AI
				local isAI = true 
				for key , value in pairs(coalition.getPlayers(Unit.getCoalition(unit))) do
					local myUnit = Unit.getName(value)
					if myUnit == myWhichUnit then isAI = false  end 
				end 
				if isAI == true then removeTarget ( { unit=myWhichUnit , group=myGroupName } )	end 
			end 			
		end	
		--- SHOOTING GUNS ---
		if event.id == world.event.S_EVENT_SHOOTING_START then 
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " has started shooting"   , 10 ) end   
		end
		if event.id == world.event.S_EVENT_SHOOTING_END then 
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " has finished shooting"   , 10 ) end    
		end
		--- SHOOTING MISSLES ---
		if event.id == world.event.S_EVENT_SHOT then 
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " Unit has shot missle or dropped bomb"   , 10 ) end 
		end
		--- PILOT DEAD ---
		if event.id == world.event.S_EVENT_DEAD then  
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " Unit is event dead"   , 10 ) end 
			if myGroupName ~= "Scenery Object" then
				removeTarget ( { unit=myWhichUnit , group=myGroupName } )
			end
		end
		--- UNIT DEAD ---
		if event.id == world.event.S_EVENT_PILOT_DEAD then 
			-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " Unit is pilot dead"   , 10 ) end 
			if gPlayers[myWhichUnit] ~= nil then
					-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " is pilot dead "  ..event.id  , 10 ) end 
				  removePlayerFromMission ( { unit=myWhichUnit } )
			else
				removeTarget ( { unit=myWhichUnit , group=myGroupName } )
			end 
		end
		-- HUMAN FAILURE COUNT
		if event.id == world.event.S_EVENT_HUMAN_FAILURE then
			-- if Debugging == true then printDebug ("EventHandler" , "An Event type human failure occured :"  .. event.id , 10 ) end
		end
	
		if event.id == world.event.S_EVENT_BASE_CAPTURED then
			airbaseCaptured ( {airbase=Airbase.getName(event.place) , unit=unit} )
			--gMissionsRunning[Airbase.getID(event.place)] = nil
			--timer.scheduleFunction(Group.destroy, Group.getByName( myGroupName ) , timer.getTime()+ 10 )
		end

	end -- if event.id == world.event.S_EVENT_MISSION_END then
end
function loadLanguages ()
	gSayThis = {}
	gSayThis["English"] = {}
	gSayThis["English"].languagenow = "The language is now English"
	gSayThis["English"].flyheading = "Fly heading"
	
	gSayThis["English"].searcharea = "Search area for"
	gSayThis["English"].degrees = "degrees"
	gSayThis["English"].fortargettype = "For target type"
	gSayThis["English"].formissiontype = "For Mission"
	gSayThis["English"].ontargettype = "on target type"
	gSayThis["English"].protect_troops = "Protect the ground troops as they attempt to sieze control of" 
	gSayThis["English"].pickuptroops = "Pickup Troops at heading"
	gSayThis["English"].inserttroops = "Insert troops close to marker"
	gSayThis["English"].extracttroops ="Extract the troops to heading"
	gSayThis["English"].protect_friendy = "Protect friendly" 
	gSayThis["English"].destroy_enemy = "Destroy enemy"
	gSayThis["English"].friendly = "friendly"
	gSayThis["English"].enemy = "enemy"
	gSayThis["English"].forces = "forces"	
	gSayThis["English"].oftype = "of type"
	gSayThis["English"].at = "at"
	gSayThis["English"].msl = "MSL"
	gSayThis["English"].clearedtofire = "Cleared to fire on"
	gSayThis["English"].rtb = "Return to airbase"
	gSayThis["English"].sayfor = "for"
	gSayThis["English"].sayto = "to"
	gSayThis["English"].on = "on"
	gSayThis["English"].halt = "halt"
	gSayThis["English"].support = "support"	
	gSayThis["English"].group = "group"
	gSayThis["English"].feet = "feet"
	gSayThis["English"].meters = "meters"
	gSayThis["English"].bearing = "Bearing"
	gSayThis["English"].miles = "miles"
	gSayThis["English"].kilometers = "Km"
	gSayThis["English"].distance = "Distance"
	gSayThis["English"].distancenowin = "Distance is now in"
	gSayThis["English"].was = "was"
	gSayThis["English"].the = "the"
	gSayThis["English"].sayand = "and"
	gSayThis["English"].nowis = "now is"
	gSayThis["English"].alreadyisactive = "already is active"
	gSayThis["English"].target = "Target"
	gSayThis["English"].mission = "Mission"
	gSayThis["English"].flightto = "Flight to target distance"
	gSayThis["English"].targetsdestroyed = "All active targets have been destroyed."
	gSayThis["English"].airfield = "airfield"
	gSayThis["English"].tacan = "TACAN is channel"
	gSayThis["English"].frequency = "Frequency is"
	gSayThis["English"].tanker = "Tanker"
	gSayThis["English"].notanker = "No tanker airborne. Spawn one from the preference menu"
	gSayThis["English"].notclose ="You are not close enough to show wind direction at"
	gSayThis["English"].smokeon = "smoke marker activated at"
	gSayThis["English"].yes = "Yes"
	gSayThis["English"].sayend = "End"
	gSayThis["English"].menu_mission = {  "Combat"  , "Training" }
	gSayThis["English"].historical_enemies = "Enemies Are Historically"
	gSayThis["English"].historical_enemies_are = {  "Accurate"  , "Inaccurate" , }
	gSayThis["English"].menu_vectors = "Vectors"
	gSayThis["English"].menu_tanker = "Spawn Airborne Refueling"
	gSayThis["English"].menu_vectors_items = {  "To Target"  , "To Airborne Refueling" , "To Closest Airfield" , "Show Wind Direction" } 
	gSayThis["English"].menu_preferences = "Preferences"
	gSayThis["English"].menu_category = { ["Against Ground"] = "Against Ground"  , ["Against Airborne"] = "Against Airborne"  , ["Against Vessel"] = "Against Vessel" ,["Random"] = "Random" , }
	gSayThis["English"].menu_measure = "Units of Measure"
	gSayThis["English"].menu_language = "Language"
	gSayThis["English"].menu_targetdistance = "Target Distance"
	gSayThis["English"].menu_wwiiassetpack = "World War II Asset Pack"
	gSayThis["English"].menu_detectiondistance = "Detection Distance"
	gSayThis["English"].menu_difficulty = "Difficulty"
	gSayThis["English"].menu_newtarget = "New Target"
	gSayThis["English"].menu_newmission = "New Mission"
	gSayThis["English"].menu_normal = "Normal"
	gSayThis["English"].menu_hard = "Hard"
	gSayThis["English"].menu_challenging = "Challenging"
	gSayThis["English"].menu_short = "Short"
	gSayThis["English"].menu_medium = "Medium"
	gSayThis["English"].menu_long = "Long"
	gSayThis["English"].menu_far = "Far"
	gSayThis["English"].menu_infinite = "Infinite"
	gSayThis["English"].menu_random = "Random"
	gSayThis["English"].menu_installed = "Installed"
	gSayThis["English"].menu_notinstalled = "Not Installed"
	gSayThis["English"].jumped_percent = "Being Jumped Chances"
	gSayThis["English"].percent = "Percent"
	gSayThis["English"].missioncompleted = "Mission Completed"
	gSayThis["English"].gamepause = "The game may pause while I find some targets."
	gSayThis["English"].flight = "flight"

	
	
	gSayThis["English"].flightlength = {short=gSayThis["English"].menu_short , medium=gSayThis["English"].menu_medium ,long=gSayThis["English"].menu_long , far=gSayThis["English"].menu_far ,}
	--gSayThis["English"].user_missions	= { [1] = "Airborne" , 	[2] = "Ground",	[3] = "Naval", 	[4] = "Rotary"}
	gSayThis["English"].user_missions	= { airborne = "Airborne",	ground = "Ground",	naval = "Naval", 	rotary = "Rotary"}
	gMissionCategory					= { airborne = "all" , 		ground = "all" , 	naval =  "all" , 	rotary = MissionCombat.ROTARY.category }



	gSayThis["English"].been_captured = "has been captured by the"
	gSayThis["English"].coalition = { [0]="neutral coalition" , [1]="red coalition" , [2]="blue coalition" }

	gSayThis["Spanish"] = {}
	gSayThis["Spanish"].languagenow = "El idioma ahora es español"
	gSayThis["Spanish"].sayfor = "para"
	gSayThis["Spanish"].sayto = "para"
	gSayThis["Spanish"].group = "grupo"
	gSayThis["Spanish"].on = "en"
	gSayThis["Spanish"].halt = "detener"
	gSayThis["Spanish"].support = "apoyo"
	gSayThis["Spanish"].flyheading = "Volar rumbo"
	gSayThis["Spanish"].searcharea = "Área de búsqueda para"
	gSayThis["Spanish"].degrees = "grados"
	gSayThis["Spanish"].fortargettype = "Para el tipo de destino"
	gSayThis["Spanish"].formissiontype = "Para la misión"
	gSayThis["Spanish"].ontargettype = "en tipo de destino"
	gSayThis["Spanish"].extracttroops ="Extrae las tropas al rumbo"
	gSayThis["Spanish"].oftype = "de tipo"
	gSayThis["Spanish"].friendly = "simpático"
	gSayThis["Spanish"].enemy = "enemigo"
	gSayThis["Spanish"].forces = "fuerzas"
	gSayThis["Spanish"].at = "a"
	gSayThis["Spanish"].msl = "MSL"
	gSayThis["Spanish"].clearedtofire = "Autorizado para disparar"
	gSayThis["Spanish"].rtb = "Regresar a la base aérea"
	gSayThis["Spanish"].meters = "medidores"
	gSayThis["Spanish"].bearing = "Llevando"
	gSayThis["Spanish"].feet = "pies"
	gSayThis["Spanish"].miles = "millas"
	gSayThis["Spanish"].kilometers = "Km"
	gSayThis["Spanish"].distance = "Distancia"
	gSayThis["Spanish"].distancenowin = "La distancia ahora está en"
	gSayThis["Spanish"].was = "estaba"
	gSayThis["Spanish"].the = "el"
	gSayThis["Spanish"].sayand = "y"
	gSayThis["Spanish"].nowis = "ahora es"
	gSayThis["Spanish"].alreadyisactive = "ya está activo"
	gSayThis["Spanish"].target = "Objetivo"
	gSayThis["Spanish"].mission = "Misión"
	gSayThis["Spanish"].flightto = "Vuelo a distancia objetivo"
	gSayThis["Spanish"].targetsdestroyed = "Todos los objetivos activos han sido destruidos."
	gSayThis["Spanish"].airfield = "Aeródromo"
	gSayThis["Spanish"].tacan = "TACAN es el canal"
	gSayThis["Spanish"].frequency = "Frecuencia es"
	gSayThis["Spanish"].tanker = "Petrolero"
	gSayThis["Spanish"].notanker = "Ningún petrolero en el aire. Engendra uno del menú de preferencias"
	gSayThis["Spanish"].notclose ="No estás lo suficientemente cerca como para mostrar la dirección del viento en"
	gSayThis["Spanish"].smokeon = "Marcador de humo activado a las"
	gSayThis["Spanish"].yes = "Si"
	gSayThis["Spanish"].sayend = "Finalizar"
	gSayThis["Spanish"].menu_mission = {  "Combate"  , "Formación" }
	gSayThis["Spanish"].historical_enemies = "Los Enemigos son Históricamente"  
	gSayThis["Spanish"].historical_enemies_are = {  "Preciso"  , "Incorrecto" , }
	gSayThis["Spanish"].menu_vectors = "Vectores"
	gSayThis["Spanish"].menu_tanker = "Aparecer Repostaje en el aire"
	gSayThis["Spanish"].menu_vectors_items = {  "Al objetivo"  , "Para repostar en el aire" , "Aeródromo más cercano" , "Mostrar dirección del viento" }
	gSayThis["Spanish"].menu_preferences = "Preferencias"
	gSayThis["Spanish"].menu_category = { ["Against Ground"] = "Contra tierra"  , ["Against Airborne"] = "Contra Aerotransportado"  , ["Against Vessel"] = "Contra el Buque" ,["Random"] = "Aleatorio" , }
	gSayThis["Spanish"].menu_measure = "Unidades de medida"
	gSayThis["Spanish"].menu_language = "Idioma"
	gSayThis["Spanish"].menu_targetdistance = "Distancia del objetivo"
	gSayThis["Spanish"].menu_wwiiassetpack = "Paquete de activos de WWII"
	gSayThis["Spanish"].menu_detectiondistance = "Distancia de detección"
	gSayThis["Spanish"].menu_difficulty = "Dificultad"
	gSayThis["Spanish"].menu_newtarget = "Nuevo Objetivo"
	gSayThis["Spanish"].menu_newmission = "Nueva Misión"
	gSayThis["Spanish"].menu_normal = "Normal"
	gSayThis["Spanish"].menu_hard = "Duro"
	gSayThis["Spanish"].menu_challenging = "Desafiante"
	gSayThis["Spanish"].menu_short = "Corto"
	gSayThis["Spanish"].menu_medium = "Medio"
	gSayThis["Spanish"].menu_long = "Largo"
	gSayThis["Spanish"].menu_far = "Lejos"
	gSayThis["Spanish"].menu_infinite = "Infinito"
	gSayThis["Spanish"].menu_random = "Aleatorio"
	gSayThis["Spanish"].menu_installed = "Instalado"
	gSayThis["Spanish"].menu_notinstalled = "No Instalado"
	gSayThis["Spanish"].jumped_percent = "Posibilidades de ser saltado"
	gSayThis["Spanish"].percent = "Por ciento"
	gSayThis["Spanish"].missioncompleted = "Misión completada"
	gSayThis["Spanish"].gamepause = "El juego puede pausar mientras encuentro algunos objetivos."
	gSayThis["Spanish"].flight = "vuelo"

	
	gSayThis["Spanish"].flightlength = {short=gSayThis["Spanish"].menu_short , medium=gSayThis["Spanish"].menu_medium ,long=gSayThis["Spanish"].menu_long , far=gSayThis["Spanish"].menu_far ,}
	--gSayThis["Spanish"].user_missions = { [1] = "Aerotransportado" , [2] = "Suelo" , [3] = "Naval" ,  [4] = "Giratoria"}
	gSayThis["Spanish"].user_missions	= { airborne = "Aerotransportado",	ground = "Suelo",	naval = "Naval", 	rotary = "Giratoria"}
	gSayThis["Spanish"].protect_troops = "Proteja a las tropas terrestres mientras intentan tomar el control de"
	gSayThis["Spanish"].pickuptroops = "Recoger tropas en el rumbo"
	gSayThis["Spanish"].inserttroops = "Inserta tropas cerca del marcador"
	gSayThis["Spanish"].protect_friendy = "Proteger Amistoso"
	gSayThis["Spanish"].destroy_enemy = "Destruye al enemigo"
	gSayThis["Spanish"].been_captured = "ha sido capturado por el"
	gSayThis["Spanish"].coalition = { [0]="coalición neutral" , [1]="coalición rojo" , [2]="coalición azul" }
end
function loadMissionsChoices ( input )
	gMissions = {}
	-- AIRBORNE MISSIONS
	gMissions[gSayThis["English"].user_missions["airborne"]] = {
		bomberescort = { menu="Bomber Escort" , description="Intercept friendly bombers and protect them from enemy fighters" , antidescription="Intercept enemy bombers and destroy them" ,} , 
		cap_ground  = { menu="CAP For Ground" , description="Protect Friendly Forces" , antidescription="Intercept Enemy Forces" , settings="ground" } , 
		cap_airborne  = { menu="CAP For Airborne" , description="Protect Friendly Forces" , antidescription="Intercept Enemy Forces" , settings="airborne" } , 
		-- bombers = { menu="Bombers Inbound" , description="Mission Desc" } , 
		-- fightersweep = { menu="Fighter Sweep" , description="Mission Desc" } ,
	}
	-- GROUND MISSIONS
	gMissions[gSayThis["English"].user_missions["ground"]] = {
		beachlanding = { menu="Beach Landing" , guidance="Landing forces" , description="Prevent the enemy forces from landing on the beach" , antidescription="Support the allied forces landing on the beach" , unique=true } ,
		captureAirfield = { menu="Capture Airfield" , guidance="Airfield defenses" , description="Destroy all the enemy forces and capture the airfield at" , antidescription="Prevent the Ground forces trying to capture the airfield" , unique=true } ,
		--destroybridge = { menu="Destroy The bridge" , description="Mission Desc" } ,
	}
	-- NAVAL MISSIONS
	gMissions[gSayThis["English"].user_missions["naval"]] = {
		wolfpack = { menu="Wolfpack" , description="Mission Desc" } ,
		navalconvoy = { menu="Naval Convoy" , description="Mission Desc" } ,
	}
	-- IF PLAYER IS IN ROTARY LOAD MISSIONS
	if AircraftType[gPlayerGroups[input.group].key].category==MissionCombat.ROTARY.category then 
		gMissions[gSayThis["English"].user_missions["rotary"]] = {
		troopExtract = { menu="Troop Extraction" , guidance="Hot Extraction Zone" , description="Extract the troops" , antidescription="Stop the helicopters from rescuing troops" , unique=true } ,
		troopInsert = { menu="Troop Insertion" , guidance="Hot Insertion Zone" , description="Air Assault to insert troops" , antidescription="Stop the helicopters from inserting troops" , unique=true } ,
		}
	end
	
	return gMissions
end
function missionRadioItems ( input ) 
	loadMissionsChoices ( input ) 
	local myLanguage = gPlayerGroups[input.group].preferences.language
	for typeKey,typeValue in pairs(gSayThis[gPlayerGroups[input.group].preferences.language].user_missions) do 
		if AircraftType[gPlayerGroups[input.group].key].category==gMissionCategory[typeKey] or gMissionCategory[typeKey] == "all" then 
			local subMenu = missionCommands.addSubMenuForGroup(input.groupID, typeValue,input.menu)
			local myTypeValue = gSayThis["English"].user_missions[typeKey]

			local mySortedCTable= {}
			for n in pairs(gMissions[myTypeValue]) do table.insert(mySortedCTable, n) end
			table.sort(mySortedCTable)
		
			-- for missionKey,missionValue in pairs(gMissions[myTypeValue]) do 
			for missionKey,missionValue in ipairs(mySortedCTable) do 
				-- local menuItem = missionCommands.addCommandForGroup(input.groupID, missionValue.menu, subMenu , doMenuItems, {action="missions" , group = input.group , guidance=missionValue.guidance, mission=missionKey , menu= missionValue.menu , desc=missionValue.description,settings=missionValue.settings, })
			local mySortedValues = gMissions[myTypeValue][missionValue]
			local menuItem = missionCommands.addCommandForGroup(input.groupID, mySortedValues.menu, subMenu , doMenuItems, {action="missions" , group = input.group , guidance=mySortedValues.guidance, mission=missionValue , menu= mySortedValues.menu , desc=mySortedValues.description,settings=mySortedValues.settings, })

			end
		
		end
	end
end 

function doRadioCommand (input)
	local myUnitObject = Unit.getByName(input.unit)
	local myGroupObject = Unit.getGroup(myUnitObject)
	local myGroupName = Group.getName(myGroupObject) 
	local myGroupID = Group.getID(myGroupObject)
	local myLanguage = gPlayerGroups[myGroupName].preferences.language
	missionCommands.removeItemForGroup(myGroupID, nil )
	local commandDB = {} 

	local menuName = gSayThis[myLanguage].menu_newtarget  .. " (" .. gSayThis[myLanguage].flightlength[gPlayerGroups[myGroupName].preferences.flightlength] .. " " .. gSayThis[myLanguage].flight .. ")" 
	local menu1 = missionCommands.addSubMenuForGroup(myGroupID, menuName, commandDB[menuName] )
	setNewTargetMenu ( {menu=menu1 , groupID=myGroupID , group=myGroupName , country=gPlayerGroups[myGroupName].country, accurate=gPlayerGroups[myGroupName].preferences.historicalaccurate , enterservice=gPlayerGroups[myGroupName].enterservice , retired=gPlayerGroups[myGroupName].retired} )
	--local menuItem = missionCommands.addCommandForGroup(myGroupID, myGroupName, menu1 , doMenuItems, {action="newtarget" , group = myGroupName , setting="on" , })
	-- MISSIONS MENU
	-- if gDev ~= nil then
		local menuName = gSayThis[myLanguage].menu_newmission  --.. " (" .. gSayThis[myLanguage].flightlength[gPlayerGroups[myGroupName].preferences.flightlength] .. ")" 
		local menu1 = missionCommands.addSubMenuForGroup(myGroupID, menuName, commandDB[menuName] )
		missionRadioItems ( {menu=menu1 , groupID=myGroupID , group=myGroupName , enterservice=gPlayerGroups[myGroupName].enterservice , retired=gPlayerGroups[myGroupName].retired} )
	-- end 
	
	-- END THE MISSION 
	if gTargets[myGroupName] ~= nil then
		local myText = gSayThis[myLanguage].sayend .. " " .. gSayThis[myLanguage].the .. " "
		if gMissionsRunning [myGroupName] ~= nil then myText = myText .. gSayThis[myLanguage].mission else myText = myText .. gSayThis[myLanguage].target end 
		local menu1 = missionCommands.addSubMenuForGroup(myGroupID, myText .. "?", commandDB[menuName]  )
		local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].yes .. "-" .. myText , menu1 , doMenuItems, {action="end_mission" , group = myGroupName , unit=input.unit , })
	end 
	-- VECTORS MENU
	local menuName = gSayThis[myLanguage].menu_vectors  
	local vectors_menu = missionCommands.addSubMenuForGroup(myGroupID, menuName, commandDB[menuName] )
	-- for i, value in pairs(gSayThis["English"].menu_vectors_items) do
		-- local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_vectors_items[i], vectors_menu , doMenuItems, {action="vectors" , group = myGroupName , unit=input.unit, setting=value , })
	-- end 
	if gTargets[myGroupName] ~= nil then
		local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_vectors_items[1], vectors_menu , doMenuItems, {action="vectors" , group = myGroupName , unit=input.unit, setting=gSayThis["English"].menu_vectors_items[1] , })
	end
	if AircraftType[gPlayers[input.unit].key].tanker ~= nil then
		local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_vectors_items[2], vectors_menu , doMenuItems, {action="vectors" , group = myGroupName , unit=input.unit, setting=gSayThis["English"].menu_vectors_items[2] , })
	end
	
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_vectors_items[3], vectors_menu , doMenuItems, {action="vectors" , group = myGroupName , unit=input.unit, setting=gSayThis["English"].menu_vectors_items[3] , })	
	
	if gAllowWindSock == true then 
		local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_vectors_items[4], vectors_menu , doMenuItems, {action="vectors" , group = myGroupName , unit=input.unit, setting=gSayThis["English"].menu_vectors_items[4] , })
	end
	
	local menuName = gSayThis[myLanguage].menu_preferences  
	local preferences_menu = missionCommands.addSubMenuForGroup(myGroupID, menuName, commandDB[menuName] )
	
	local menuName = gSayThis[myLanguage].historical_enemies
	local menu1 = missionCommands.addSubMenuForGroup(myGroupID, menuName, preferences_menu )
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].historical_enemies_are[1], menu1 , doMenuItems, {action="historicalenemies" , group = myGroupName , setting=gSayThis["English"].historical_enemies_are[1] , })
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].historical_enemies_are[2], menu1 , doMenuItems, {action="historicalenemies" , group = myGroupName , setting=gSayThis["English"].historical_enemies_are[2] , })
	
	local menuName = gSayThis[myLanguage].jumped_percent
	local menu1 = missionCommands.addSubMenuForGroup(myGroupID, menuName, preferences_menu )
	local menuItem = missionCommands.addCommandForGroup(myGroupID, "0 " ..gSayThis[myLanguage].percent , menu1 , doMenuItems, {action="jumpedpercent" , group = myGroupName , setting=0 , })
	for i=1,9 do
		local myValue = math.floor((100/9)*i)
		local menuItem = missionCommands.addCommandForGroup(myGroupID, myValue .. " " ..gSayThis[myLanguage].percent , menu1  , doMenuItems, {action="jumpedpercent" , group = myGroupName , setting=myValue , })
	end 
	--local menuItem = missionCommands.addCommandForGroup(myGroupID, "100 " ..gSayThis[myLanguage].percent , menu1 , doMenuItems, {action="jumpedpercent" , group = myGroupName , setting=100 , })
		
	if AircraftType[gPlayers[input.unit].key].tanker ~= nil then
		local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_tanker, preferences_menu , doMenuItems, {action="tanker" , group = myGroupName , unit=input.unit, setting=gSayThis["English"].menu_tanker , })
	end
	local menuName = gSayThis[myLanguage].menu_difficulty  
	local menu1 = missionCommands.addSubMenuForGroup(myGroupID, menuName, preferences_menu )
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_normal, menu1 , doMenuItems, {action="difficulty" , group = myGroupName , setting=gDifficultySettings.normal , })
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_hard, menu1 , doMenuItems, {action="difficulty" , group = myGroupName , setting=gDifficultySettings.hard , })
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_challenging, menu1 , doMenuItems, {action="difficulty" , group = myGroupName , setting=gDifficultySettings.challenging  , })
	
	local menuName = gSayThis[myLanguage].menu_targetdistance 
	local menu1 = missionCommands.addSubMenuForGroup(myGroupID, menuName, preferences_menu )
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_short, menu1 , doMenuItems, {action="targetrange" , group = myGroupName , setting=gTargetRange.short , desc="short"})
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_medium, menu1 , doMenuItems, {action="targetrange" , group = myGroupName , setting=gTargetRange.medium , desc="medium"})
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_long, menu1 , doMenuItems, {action="targetrange" , group = myGroupName , setting=gTargetRange.long  , desc="long"})
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_far, menu1 , doMenuItems, {action="targetrange" , group = myGroupName , setting=gTargetRange.far  , desc="far"})
	
	local menuName = gSayThis[myLanguage].menu_detectiondistance 
	local menu1 = missionCommands.addSubMenuForGroup(myGroupID, menuName, preferences_menu )
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_short, menu1 , doMenuItems, {action="detectrange" , group = myGroupName , setting=gTargetDetectRange.short , desc="short"})
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_medium, menu1 , doMenuItems, {action="detectrange" , group = myGroupName , setting=gTargetDetectRange.medium , desc="medium"})
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_long, menu1 , doMenuItems, {action="detectrange" , group = myGroupName , setting=gTargetDetectRange.long  , desc="long"})
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_far, menu1 , doMenuItems, {action="detectrange" , group = myGroupName , setting=gTargetDetectRange.far  , desc="far"})
				
	local menuName = gSayThis[myLanguage].menu_measure 
	local menu1 = missionCommands.addSubMenuForGroup(myGroupID, menuName, preferences_menu )
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].feet:sub(1,1):upper()..gSayThis[myLanguage].feet:sub(2), menu1 , doMenuItems, {action="setmeasurements" , group = myGroupName , setting="feet" , })
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].meters:sub(1,1):upper()..gSayThis[myLanguage].meters:sub(2), menu1 , doMenuItems, {action="setmeasurements" , group = myGroupName , setting="meters" , })
	
	local menuName = gSayThis[myLanguage].menu_wwiiassetpack
	local menu1 = missionCommands.addSubMenuForGroup(myGroupID, menuName, preferences_menu )
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_installed, menu1 , doMenuItems, {action="WWIIasset" , group = myGroupName , setting=true  , desc="True"})
	local menuItem = missionCommands.addCommandForGroup(myGroupID, gSayThis[myLanguage].menu_notinstalled, menu1 , doMenuItems, {action="WWIIasset" , group = myGroupName , setting=false  , desc="False"})	
	
	local menuName = gSayThis[myLanguage].menu_language 
	local menu1 = missionCommands.addSubMenuForGroup(myGroupID, menuName .. "( Language )", preferences_menu )
	for i, value in pairs(gLanguageTypes) do
		local menuItem = missionCommands.addCommandForGroup(myGroupID, value, menu1 , doMenuItems, {action="setlanguage" , group = myGroupName , setting=value  , })
	end
	
	if gDev ~= nil then
		-- local menuItem = missionCommands.addCommandForGroup(myGroupID, "Fill Parking", commandDB[menuName] , doMenuItems, {action="parking" , group = myGroupName , setting="parking" , })
		
		
		local menuItem = missionCommands.addCommandForGroup(myGroupID, "Find Beach", commandDB[menuName] , doMenuItems, {action="findbeach" , group = myGroupName , setting="beach" , })

		local menuItem = missionCommands.addCommandForGroup(myGroupID, "Destroy Enemy", commandDB[menuName] , doMenuItems, {action="destroy" , group = myGroupName , setting="unitone" , })
	--	local menuItem = missionCommands.addCommandForGroup(myGroupID, "Land Enemy", commandDB[menuName] , doMenuItems, {action="land" , group = myGroupName , setting="unitone" , })
	--	local menuItem = missionCommands.addCommandForGroup(myGroupID, "Destroy Friendly", commandDB[menuName] , doMenuItems, {action="destroy" , group = myGroupName , friendly=true, setting="unitone" , })
	
	end
end 

function missionSelector ( input )
	input.friendlycoa = Group.getCoalition(Group.getByName(input.group))
	input.friendlycountryid =  Unit.getCountry(Group.getByName(input.group):getUnit(1))
	input.friendlycountry = country.name[input.friendlycountryid]
	
	input.enemycoa = coalition.side.RED
	input.enemycountry = gRedCountries[math.random(1,#gRedCountries)]
	input.enemycountryid = country.id[input.enemycountry] 
	
	if input.friendlycoa == coalition.side.RED then 
		input.enemycoa = coalition.side.BLUE
		input.enemycountry = gBlueCountries[math.random(1,#gBlueCountries)]
		input.enemycountryid = country.id[input.enemycountry] 
	end 
	-- GROUND MISSIONS
	-- BEACH LANDING
	if input.menu == gMissions[gSayThis["English"].user_missions["ground"]].beachlanding.menu then
		local myBeachActive = false 
		local myDefendingCounty = ""
		for key , value in pairs(gMissionsRunning) do
			if value.location ~= nil then 
				myBeachActive = true 
				myDefendingCounty = value.friendlycountryid
			end
		end 
		if myBeachActive == false then 
			mission_beachlanding ( input )
		else
			
			local myLanguage = gPlayerGroups[input.group].preferences.language
			local myText = gSayThis[myLanguage].mission .. " " .. input.menu .. " " .. 	gSayThis[myLanguage].alreadyisactive .. "."
			
			local myAction = gSayThis[myLanguage].support .. " " .. gSayThis[myLanguage].the .. " " .. gSayThis[myLanguage].friendly 
			if input.friendlycountryid == myDefendingCounty then myAction = gSayThis[myLanguage].halt .. " " .. gSayThis[myLanguage].the .. " " .. gSayThis[myLanguage].enemy  end 
			myText = myText .. " " .. myAction:sub(1,1):upper() .. myAction:sub(2)  .. " " .. gSayThis[myLanguage].forces
			--.. " " .. gSayThis[myLanguage].at .. " " .. gSayThis[myLanguage].airfield .. " " .. myEnemyAirport.name
			doPrintThis ({clearview = false  , group=input.group, duration= 30 , text=myText })
		end 
	end 
	-- CAPTURE CLOSESST AIRFIELD
	if input.menu == gMissions[gSayThis["English"].user_missions["ground"]].captureAirfield.menu then
		mission_CaptureAirfield_Start ( input )
		--gMissionsRunning[input.menu] = { country=input.friendlycountry , group=input.group }
	end
	-- NAVAL MISSIONS --
	if input.menu == gMissions[gSayThis["English"].user_missions["naval"]].wolfpack.menu then
		mission_GenericSpawn ( input )
		--gMissionsRunning[input.menu] = { country=input.friendlycountry , group=input.group }
	end
	if input.menu == gMissions[gSayThis["English"].user_missions["naval"]].navalconvoy.menu then
		mission_NavalConvoySpawn ( input )
		--gMissionsRunning[input.menu] = { country=input.friendlycountry , group=input.group }
	end
	
	-- AIRBORNE MISSIONS --
	if input.menu == gMissions[gSayThis["English"].user_missions["airborne"]].bomberescort.menu then
		mission_BomberEscort ( input )
		-- mission_BomberEscort
		--gMissionsRunning[input.menu] = { country=input.friendlycountry , group=input.group }
	end
	if input.menu == gMissions[gSayThis["English"].user_missions["airborne"]].cap_ground.menu or 
		input.menu == gMissions[gSayThis["English"].user_missions["airborne"]].cap_airborne.menu  then
		mission_CombatAirPatrol ( input )
		-- mission_BomberEscort
		--gMissionsRunning[input.menu] = { country=input.friendlycountry , group=input.group }
	end
	
	-- ROTARY Missions
	
	if AircraftType[gPlayerGroups[input.group].key].category == MissionCombat.ROTARY.category then -- only if group is rotary
		if input.menu == gMissions[gSayThis["English"].user_missions["rotary"]].troopExtract.menu then
			mission_TroopExtraction ( input )
			--gMissionsRunning[input.menu] = { country=input.friendlycountry , group=input.group }
		end
		if input.menu == gMissions[gSayThis["English"].user_missions["rotary"]].troopInsert.menu then
			mission_TroopInsertion ( input )
		end
	end
end

function removeActiveMissions ( input )
	if gMissionsRunning[input.group] ~= nil then 
		for mission_name, value in pairs(gMissionsRunning) do
			if input.group == value.group then 

				timer.scheduleFunction(removeTargetFromMission, {groups=gMissionsRunning[value.group].groups, friendlygroups=gMissionsRunning[value.group].friendlygroups, group=value.group} , timer.getTime()+ (gTargetDestroyDelay*60) )
				gMissionsRunning[mission_name] = nil 
			end 
		end
	elseif gTargets[input.group] ~= nil then
		timer.scheduleFunction(removeTargetFromMission, {groups=gTargets[input.group].groups, friendlygroups=gTargets[input.group].friendlygroups , group=input.group} , timer.getTime()+ (gTargetDestroyDelay*60) )
	end
	gTargets[input.group] = nil 
	gHiddenTargets[input.group] = nil
	gLocationTriggers[input.group] = nil
end
function missionsAllTargetsDestroyed ( input )

	if input.menu == gMissions[gSayThis["English"].user_missions["ground"]].captureAirfield.menu then
		mission_CaptureAirfield_TargetsDestroyed ( input )
		removeActiveMissions ( {group=input.name , } )
	end
	
	if input.menu == gMissions[gSayThis["English"].user_missions["naval"]].wolfpack.menu then
		-- timer.scheduleFunction(removeTargetFromMission, {groups=gMissionsRunning[input.name].friendlygroups, group=input.name} , timer.getTime()+ (gTargetDestroyDelay*60) )
		mission_GenericSpawn_TargetsDestroyed ( {group=input.name , } )
		--timer.scheduleFunction(removeTargetFromMission, {groups=gMissionsRunning[input.name].friendlygroups, group=input.name} , timer.getTime()+ (gTargetDestroyDelay*60) )
		removeActiveMissions ( {group=input.name , } )
	end
	
	if input.menu == gMissions[gSayThis["English"].user_missions["naval"]].wolfpack.menu
		or input.menu == gMissions[gSayThis["English"].user_missions["naval"]].navalconvoy.menu then
		-- timer.scheduleFunction(removeTargetFromMission, {groups=gMissionsRunning[input.name].friendlygroups, group=input.name} , timer.getTime()+ (gTargetDestroyDelay*60) )
		mission_GenericSpawn_TargetsDestroyed ( {group=input.name , } )
		--timer.scheduleFunction(removeTargetFromMission, {groups=gMissionsRunning[input.name].friendlygroups, group=input.name} , timer.getTime()+ (gTargetDestroyDelay*60) )
		removeActiveMissions ( {group=input.name , } )
	end
	
	if input.menu == gMissions[gSayThis["English"].user_missions["airborne"]].bomberescort.menu then
		mission_GenericSpawn_TargetsDestroyed ( {group=input.name , } )
		removeActiveMissions ( {group=input.name , } )
	end
	if input.menu == gMissions[gSayThis["English"].user_missions["airborne"]].cap_ground.menu
		or input.menu == gMissions[gSayThis["English"].user_missions["airborne"]].cap_airborne.menu then
		mission_GenericSpawn_TargetsDestroyed ( {group=input.name , } )
		removeActiveMissions ( {group=input.name , } )
	end
	
	if AircraftType[gPlayerGroups[input.name].key].category == MissionCombat.ROTARY.category then -- ONLY IF GROUP IS ROTARY WING
		if input.menu == gMissions[gSayThis["English"].user_missions["rotary"]].troopInsert.menu then
			mission_TroopInsertionDestroyed ( {group=input.name , } )
		end
	end 
end

--- MISSIONS ON THE GROUND ---
function mission_CaptureAirfield_Start ( input ) -- CAPTURE AIRFIELD
 
	local myEnemyGroups = {}
	local myFriendlyGroups = {}
	local myVariance = 300
	local myDistance = 1000
	local myMaxRadarAA = 7
	local myEnemyFighterCount = 3
	
	-- FIND CLOSEST ENEMY AIRPORT
	local myUnitName = Unit.getName(Group.getByName(input.group):getUnit(1))
	local myLanguage = gPlayerGroups[input.group].preferences.language
	local myPosition = centerUnitCoordinates (myUnitName)
	--local myEnemyAirport = findClosestAirbase ({position=myPosition ,coalition=input.enemycoa })
	local myEnemyAirport = findClosestAirbase ({position=myPosition ,notcoalition=input.friendlycoa })
	
	local myEnemyPosition = getPointOnRadian ( { diameter=2000 , pos=myEnemyAirport.point , angle = myEnemyAirport.angle })
	local myFriendlyPosition = getPointOnRadian ( { diameter=5000 , pos=myEnemyAirport.point , angle = myEnemyAirport.angle })

	local myRunningThisAirport = false
	for key , value in pairs(gMissionsRunning) do
		if value.airbase == myEnemyAirport.name then myRunningThisAirport = true end
	end 
	if  myRunningThisAirport == true then
		local myLanguage = gPlayerGroups[input.group].preferences.language
		local myText = gSayThis[myLanguage].mission .. " " .. input.menu .. " " .. 	gSayThis[myLanguage].alreadyisactive ..
		" " .. gSayThis[myLanguage].at .. " " .. gSayThis[myLanguage].airfield .. " " .. myEnemyAirport.name

		--doInstructPlayersV1 ( {group=input.group} )
		doPrintThis ({clearview = false  , group=input.group, duration= 30 , text=myText })
	else
		removeActiveMissions ( {group=input.group , } )
		-- CREATE THE ENEMY AA TARGET
		input.mission=MissionCombat.ANTIAIR
		input.category=CombatCategory.Ground 
		input.enterservice = gPlayerGroups[input.group].enterservice
		input.retired = gPlayerGroups[input.group].retired
		input.country = gPlayerGroups[input.group].country
		input.accurate = gPlayerGroups[input.group].preferences.historicalaccurate
			
		local myANTIAIRTargets = checkTargetTables (input) -- LOOK FOR A TARGET 
		local myCountem = 0
		
		if #myANTIAIRTargets < myMaxRadarAA then
			for i=(#myANTIAIRTargets+1) ,myMaxRadarAA do
				myANTIAIRTargets[i] = myANTIAIRTargets[1]
			end
		end
		
		local myLimit = #myANTIAIRTargets		
			
		if ( input.enterservice >= 1959 and #myANTIAIRTargets >= myMaxRadarAA ) or (myLimit > myMaxRadarAA ) then myLimit = myMaxRadarAA end

		
		local myAASpawnPoints = {}
		gTargetsCount = gTargetsCount + 1 
		for i=1,myLimit do
			myCountem = myCountem + 1
			local myHeading = (math.pi/2)*i
			local myUnits = {}
			local myRandomPoint = RandomSpawnPoints ( {position=myEnemyPosition, variance=myVariance , distance=myDistance, groupname=myANTIAIRTargets[i].type , type=myANTIAIRTargets[i].type, country=myCountry , notsurface=5 } ) -- TOOLBOX ROUTINE
			
			--- BUILD THE RADAR UNITS 
			myUnits[#myUnits+1] = { name = "EA" .. gTargetsCount .. "G" .. i .. "U1"  , heading = myHeading , action= "Off Road" , spawn_type=Group.Category.GROUND , skill = gEnemySkillLevel  , type=myANTIAIRTargets[i].type, position=myAASpawnPoints[i] , speed=0 , alt=0 , altType="RADIO", }	
			if myANTIAIRTargets[i].radar ~= nil then 
				local myNumberUnits = 1 		
				for radarKey,radarValue in pairs(myANTIAIRTargets[i].radar) do                                                                            
					local myOffset = {}   
					myOffset.x = myRandomPoint.x + (math.random( -50 , 50 ) * myNumberUnits  )                                                                    
					myOffset.z = myRandomPoint.z + (math.random( -50 , 50 ) * myNumberUnits  )                                                                    
					myUnits[#myUnits+1] = { name = "ER" .. gTargetsCount .. "G" .. i .. "R" .. myNumberUnits , heading = myHeading , action= "Off Road" , spawn_type=Group.Category.GROUND , skill = gEnemySkillLevel  , type=radarValue, position=myOffset , speed=0 , alt=0 , altType="RADIO", }	
					myNumberUnits  =  myNumberUnits  + 1                                                                                      
				end                                                                                                                           
			end 
			gCurrentGroupID = gCurrentGroupID + 1 
			-- if Debugging == true then printDebug ("EventHandler" , "gCurrentGroupID " .. gCurrentGroupID , 10 ) end
			local mySpawn = { name = "EA" .. gTargetsCount .. "G" .. i , groupID=gCurrentGroupID, units=myUnits, action= "Off Road" , lateActivation=true , spawn_type=Group.Category.GROUND , position=myRandomPoint , country=input.enemycountry , type=myANTIAIRTargets[i].type, }
			local myBuiltSpawn = doBuildSpawn (mySpawn)
			coalition.addGroup(input.enemycountryid, Group.Category.GROUND, myBuiltSpawn ) 
			myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
		end
		
		-- CREATE THE ENEMY FIGHTERS ON THE GROUND
		input.mission=MissionCombat.FIGHTER
		input.category=CombatCategory.Airborne 
		local myFighterTargets = checkTargetTables (input) -- LOOK FOR A TARGET 
		local myFighterType = myFighterTargets[math.random(1,#myFighterTargets)].type
		local myFighterKey = string.upper(myFighterType:gsub('[%p%c%s]', '') )
		local myFighterPayload = {fuel=Targets[myFighterKey].fuel, pylons=Targets[myFighterKey].pylons,  ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100}
		
		
		local myUnits = {}
		for i=1,myEnemyFighterCount do
			myUnits[#myUnits+1] = { name = "EF" .. gTargetsCount .. "G1U" .. i , payload=myFighterPayload, heading = myHeading , spawnFrom= "TakeOffParking" , spawn_type=Group.Category.AIRPLANE , skill = gEnemySkillLevel  , type=myFighterType, airfield=myEnemyAirport.id, speed=0 , alt=0 , altType="RADIO", }
		end 
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "EF" .. gTargetsCount .. "G1" , groupID=gCurrentGroupID, units=myUnits, spawnFrom= "TakeOffParking" , lateActivation=true , spawn_type=Group.Category.AIRPLANE , airfield=myEnemyAirport.id, country=input.enemycountry ,  type=myFighterType, }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.enemycountryid, Group.Category.AIRPLANE, myBuiltSpawn ) 
		myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
		
		local myAlt = 3000
		if input.enterservice > 1950 then myAlt = 10000 end 
		myLocation = { callsign_group = mySpawn.name, point = myEnemyPosition , type = "Circle" , alt = myAlt , speed = Targets[myFighterKey].speed*.75, racetrackwidth = 2000 }  -- "Race-Track" or "Circle" -- zone = "TaskGroupSpawnZone"
		timer.scheduleFunction(doHoldPattern, myLocation, timer.getTime()+ 20 )  
		

			
		local myTargetName = "Enemy " ..  gTargetsCount
		local myTargetKey = string.upper(Targets.OUTPOST.type:gsub('[%p%c%s]', '') )

		
		local myHiddenGroups = {}
		for key , value in pairs(myEnemyGroups) do
			myHiddenGroups[#myHiddenGroups+1] = value
		end
		for key , value in pairs(myFriendlyGroups) do
			myHiddenGroups[#myHiddenGroups+1] = value
		end
		local myTypename = input.menu .. " " .. myEnemyAirport.name 
		local myMissionType = gSayThis[myLanguage].destroy_enemy .. " " .. gSayThis[myLanguage].sayto
		-- LOAD INTO TARGET TABLE
		local myPlayerGroups = {[1]={name=input.group,type=gPlayerGroups[input.group].type}}
		local myMessages =	{[1]="flyheading" ,[2]="clearedtofire",}
		local myTriggers = {[1]={groups=myPlayerGroups, atgroup=myEnemyGroups[1].name} ,  -- group near atgroup or atpoint
							[2]={groups=myPlayerGroups, atgroup=myEnemyGroups[1].name} ,
							}
		local myHiddenTargets = {[1]=myEnemyGroups ,}

		gTargets[input.group] = { name=input.group, target=myTargetName , groups=myEnemyGroups, friendlygroups=myFriendlyGroups , startpoint=myEnemyAirport.point, activated=false , 
		typename=myTypename ,  menu=input.menu, key=myTargetKey, friendlycountryid=input.friendlycountryid , enemycountryid=input.enemycountryid , airportid=myEnemyAirport.id , noreturn=true, mission=true ,  
		missiontype=myMissionType , triggers=myTriggers, messages=myMessages , phrasecount=1, }  
		
		gHiddenTargets[input.group] = { name=input.group,  groups=myHiddenTargets , triggers=myTriggers , menu=input.menu }
		-- SET THE ACTIVE Mission
		-- gMissionsRunning[input.group] = {name=input.group, group=input.group, friendlycountry=input.friendlycountry , friendlycountryid=input.friendlycountryid, airbase=myEnemyAirport.name, missiontype=myMissionType ,  menu=input.menu , typename=myTypename, groups = myEnemyGroups , startpoint = myEnemyAirport.point  }
		gMissionsRunning[input.group] = {name=input.group, group=input.group, airbase=myEnemyAirport.name, groups = myEnemyGroups , menu=input.menu , startpoint = myEnemyAirport.point , friendlycountryid=input.friendlycountryid,  }

		-- doInstructPlayers ( {group=input.group} )
		doInstructPlayers ( {group=input.group} )
		
		doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
	end
end
function mission_CaptureAirfield_TargetsDestroyed ( input )
		local myWaypoints = { [1] = { action = "On Road", pos=input.startpoint , alt = 0  , altType="RADIO" , speed = Targets.M818.speed  }} 
		local myFriendlyStartPoint  = getPointOnRadian ( { diameter=3000 , pos=input.startpoint , angle = math.random(1,6) })
		myFriendlyStartPoint.x, myFriendlyStartPoint.z = land.getClosestPointOnRoads('roads' , myFriendlyStartPoint.x, myFriendlyStartPoint.z ) -- FIND A CLOSE ROAD TO ENDPOINT
		-- CREATE THE FRIENDLY TARGET
		gTargetsCount = gTargetsCount + 1
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name="FSF" .. gTargetsCount .. "G1" , groupID=gCurrentGroupID, skill=gFriendlySkillLevel, waypoints=myWaypoints , action= "On Road" , lateActivation=true , spawn_type=Group.Category.GROUND , type=Targets.M818.type, position=myFriendlyStartPoint , heading=3.14 , country=input.friendlycountry , speed=Targets.M818.speed , alt=0 , altType="RADIO", }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.friendlycountryid, Group.Category.GROUND, myBuiltSpawn )
		timer.scheduleFunction(trigger.action.activateGroup, Group.getByName(mySpawn.name ) , timer.getTime()+ 5 )

		-- TELL EVERYONE IN THE AREA TO PROTECT THE TROOPS
		local myFoundObjects = SearchAreaForObjects ( {point=input.startpoint , radius=20000 , category=Object.Category.UNIT ,  } )
		local myTellTheseGroups = {}
		for unit_id,unit_value in pairs(myFoundObjects) do
			--if Unit.getByName(unit_value):getCountry() == value.friendlycountryid then
			local myGroupName = Group.getName ( Unit.getGroup(Unit.getByName(unit_value)))			
			if coalition.getCountryCoalition(Unit.getByName(unit_value):getCountry()) == coalition.getCountryCoalition(input.friendlycountryid) and gPlayerGroups[myGroupName] ~= nil then
				myTellTheseGroups[myGroupName] = myGroupName
			end			
		end
		for tell_group,tell_value in pairs(myTellTheseGroups) do
			local myLanguage = gPlayerGroups[tell_group].preferences.language
			myText = gSayThis[myLanguage].protect_troops .. " " ..  input.airbase .. " " .. gSayThis[myLanguage].airfield
			doPrintThis ({clearview = gClearView  , group=tell_group, duration= 30 , text=myText })
		end 
end 
function airbaseCaptured ( input )
	
	local myCoa = 0
	if input.unit ~= nil then 
		 myCoa = Unit.getCoalition(input.unit)
	end
	
	for group ,value in pairs(gPlayerGroups) do
		local myText =   gSayThis[value.preferences.language].the:gsub("^%l", string.upper)  .. " " .. gSayThis[value.preferences.language].airfield  .. " " .. input.airbase .. " " .. gSayThis[value.preferences.language].been_captured .. " " .. gSayThis[value.preferences.language].coalition[myCoa] .."."
		doPrintThis ({clearview = false , duration= 30 , text=myText })
		
	end

end 


-- MISSIONS AIRBORNE ---
function mission_BomberEscort ( input )
	removeActiveMissions ( {group=input.group , } )
	local myEnemyGroups = {}
	local myFriendlyGroups = {}
	local myDistanceBetweenForces = 3000
	local myDistanceFromObjective = 18000
	local myFlightTimeBetweenForces = 1 -- in minutes
	local myDriveTimeBetweenForces = 1 -- in minutes
	local myUnitEnemyCounts = 3
	local myGroupEnemyCounts = 1
	local myUnitFriendlyCounts = 4
	local myGroupFriendlyCounts = 1
	local myFriendlyUnitSpaced = 200
	local myEnemyUnitSpaced = 200
	local myFriendlyGroupSpaced = 500
	local myEnemyGroupSpaced = 500
	local myRandomDistance = gPlayerGroups[input.group].preferences.targetrange + (math.random ( 3 , 10 )*1000) 
	local mySurfaceWater = {[1]="Water" ,} 
	local mySurfaceLand = {[1]="Land" ,} 
	local mySurfaceMixed = {[1]="Water" ,[2]="Land" ,}
	
	-- GET PLAYER AIRCRAFT TYPE INFORMATION
	input.enterservice = gPlayerGroups[input.group].enterservice
	input.retired = gPlayerGroups[input.group].retired
	input.country = gPlayerGroups[input.group].historicalcountry
	input.accurate = gPlayerGroups[input.group].preferences.historicalaccurate
	local myLanguage = gPlayerGroups[input.group].preferences.language
	
	-- OUR TARGET TYPES AIRBORNE
	local myFriendlyCategory = MissionCombat.BOMBER
	local myEnemyCategory = MissionCombat.FIGHTER
	local myEnemySpawnType=Group.Category.AIRPLANE
	local myFriendlySpawnType=Group.Category.AIRPLANE
	input.action = "Turning Point"
	myFriendlyCountry = Targets[gPlayerGroups[input.group].key].country -- FRIENDLY WILL END UP BEING OPPOSING SIDE OF ENEMY
	
	-- GET A ENEMY TARGET TYPE
	input.country = Targets[gPlayerGroups[input.group].key].country
	input.mission = myEnemyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET 
	local myEnemyTargets=myTargets[math.random( 1, #myTargets )] 
	
	myEnemyTargets.key = string.upper(myEnemyTargets.type:gsub('[%p%c%s]', '') )
	local myEnemyPayload = {}
	if myEnemySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myEnemyPayload  = {  ["fuel"] = myEnemyTargets.fuel , ["pylons"] = myEnemyTargets.pylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 } 
		if myEnemyTargets.enterservice <= 1958 then 
			myEnemyPayload.flare = 0 
			myEnemyPayload.chaff = 0 
		end 
	end
	
	-- GET A FRIENDLY TARGET TYPE 
	input.country = Targets[myEnemyTargets.key].country --friendly is same country as human group aircraft type
	input.mission = myFriendlyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET
	local myFriendlyTargets=myTargets[math.random( 1, #myTargets )]
	
	myFriendlyTargets.key = string.upper(myFriendlyTargets.type:gsub('[%p%c%s]', '') )
	local myFriendlyPayload = {}
	if myFriendlySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myFriendlyPayload  = {  ["fuel"] = myFriendlyTargets.fuel , ["pylons"] = myFriendlyTargets.gpylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 }
		if myFriendlyTargets.enterservice <= 1958 then 
			myFriendlyPayload.flare = 0 
			myFriendlyPayload.chaff = 0 
		end 
	end 	
	
	--FIND THE CLOSEST AIRBORNE TARGET
	local myTypename = 	myFriendlyTargets.type .. " " .. input.menu
	local myPrecision = 50 -- how big the water and land must be to decide on it
	myDistanceBetweenForces = ((myEnemyTargets.speed/3600)*(myFlightTimeBetweenForces*120))*MILES_TO_METERS
	local myPlayersAlt = GetAltitudeRangesGroup ( { group=input.group, } )
	local myFriendlyAlt = myPlayersAlt.average_msl + math.random (5,10)*1000
	local myEnemyAlt = myFriendlyAlt -- + math.random (2,4)*1000
	local myFriendlyAngle = math.random(1,6)
	local myEnemyAngle = myFriendlyAngle+(math.pi/2) - (math.random(0,5)*(math.pi/5))

	local myStartingPosition = findMatchingSurfacePoints ( {unit=Unit.getName(Group.getByName(input.group):getUnit(1)) ,surfacetypes=mySurfaceLand, distance=myRandomDistance , samples=12, precision=myPrecision } )
	myStartingPosition.position.x, myStartingPosition.position.z = land.getClosestPointOnRoads('roads' , myStartingPosition.position.x, myStartingPosition.position.z )
	-- local myEnemyAirport = findClosestAirbase ({position=centerUnitCoordinates (Unit.getName(Group.getByName(input.group):getUnit(1))) ,coalition=input.enemycoa })
	
	local myFriendlyPosition = getPointOnRadian ( { diameter=myDistanceFromObjective*2 , pos=myStartingPosition.position , angle=myFriendlyAngle })
	-- local myFriendlyPosition = getPointOnRadian ( { diameter=myDistanceFromObjective*2 , pos=myEnemyAirport.point , angle=myFriendlyAngle })
	
	local mFriendlyAirport = findClosestAirbase ({position=myStartingPosition.position ,coalition=input.friendlycoa })
	-- local mFriendlyAirport = findClosestAirbase ({position=myEnemyAirport.point ,coalition=input.friendlycoa })
	
	local myFriendlyWaypoint = mFriendlyAirport.point

	local myEnemyPosition = getPointOnRadian ( { diameter=myDistanceBetweenForces , pos=myStartingPosition.position  , angle = myEnemyAngle })
	-- local myEnemyPosition = getPointOnRadian ( { diameter=myDistanceBetweenForces , pos=myEnemyAirport.point  , angle = myEnemyAngle })

	local myBombingPoint = {x=myStartingPosition.position.x , y=myStartingPosition.position.z} 
	-- local myBombingPoint = {x=myEnemyAirport.point.x , y=myEnemyAirport.point.z} 
	
	local myEnemyTask = formation.WWIIFighterOpen -- formation always comes first in task list or will crash game
	myEnemyTask[2] = {["number"] = 2,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargets', params = { maxDistEnabled = true, maxDist = 100000 ,targetTypes = {[1] = "Strategic bombers",}, noTargetTypes = {}, priority = 0 , } }

	local myFriendlyTask =	formation.WWIIBomberTight -- formation always comes first in task list or will crash game
	myFriendlyTask[2] = {["number"] = 2,["auto"] = false,["id"] = 'CarpetBombing', params = {  point = myBombingPoint, attackQtyLimit = false, attackType = "Carpet", weaponType = 2147485694 , expend = "All", attackQty = 1, groupAttack = true, altitude = myFriendlyAlt*FEET_TO_METERS, altitudeEnabled = true, } } 
	


	-- WHICH WAY ARE FORCES HEADING
	local myHeadingEnemy = getBearingTwoPoints(myEnemyPosition , myStartingPosition.position )
	-- local myHeadingEnemy = getBearingTwoPoints(myEnemyPosition , myFriendlyPosition )
	
	local myHeadingFriendly = getBearingTwoPoints(  myFriendlyPosition, myStartingPosition.position )
	-- local myHeadingFriendly = getBearingTwoPoints(  myFriendlyPosition, myEnemyAirport.point )
	
	local myStartPoint = myFriendlyPosition -- POSITION TO DIRECT THE PLAYER TO FLY TOWARDS
	
--- CREATE THE ENEMY TARGET

	gTargetsCount = gTargetsCount + 1
	local myWaypoints={}
	myWaypoints[#myWaypoints+1] = { action = input.action, pos=myStartingPosition.position , alt = myEnemyAlt  , altType="RADIO" , speed = myEnemyTargets.speed , }
	myWaypoints[#myWaypoints+1] = { action = input.action, pos=myFriendlyPosition , alt = myEnemyAlt  , altType="RADIO" , speed = myEnemyTargets.speed , }
	
	-- myWaypoints[#myWaypoints+1] = { action = input.action, pos=myFriendlyPosition , alt = myEnemyAlt  , altType="RADIO" , speed = myEnemyTargets.speed , }
			
			
	for groups = 1, myGroupEnemyCounts do
		local myEnemyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyGroupSpaced) , pos=myEnemyPosition , angle = math.random(1,6) })

		local myUnits = {}
		for units = 1, myUnitEnemyCounts do
			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyUnitSpaced) , pos=myEnemyGroupPosition , angle = math.random(1,6) })
			myUnits[#myUnits+1] = { name = "EF" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading=myHeadingEnemy,  spawn_type=myEnemySpawnType , skill = gEnemySkillLevel  , type=myEnemyTargets.type, position=myUnitPosition  , alt=myEnemyAlt , speed=myEnemyTargets.speed, altType="RADIO", }
			if myEnemySpawnType == Group.Category.AIRPLANE or myEnemySpawnType == Group.Category.HELICOPTER then myUnits[#myUnits].payload = myEnemyPayload  end
		end

		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name="EF" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gEnemySkillLevel , action= input.action , waypoints=myWaypoints, lateActivation=true , spawn_type=myEnemySpawnType , type=myEnemyTargets.type, position=myEnemyGroupPosition , heading=myHeadingEnemy, country=input.enemycountry , speed=myEnemyTargets.speed , alt=myEnemyAlt , altType="RADIO", tasks=myEnemyTask,}
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.enemycountryid, myEnemySpawnType, myBuiltSpawn ) 
		myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true} --friendly in the group triggers enemy not players  
	end 				
	
	-- CREATE THE FRIENDLY TARGET

	for groups = 1, myGroupFriendlyCounts do
		local myFriendlyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyGroupSpaced) , pos=myFriendlyPosition , angle = math.random(1,6) })
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = input.action , pos=myFriendlyWaypoint , alt = myFriendlyAlt  , altType="RADIO" , speed =myFriendlyTargets.speed ,  }
		local myUnits = {}
		for units = 1, myUnitFriendlyCounts do
			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyUnitSpaced) , pos=myFriendlyGroupPosition , angle = math.random(1,6) })
			myUnits[#myUnits+1] = { name = "FB" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading = myHeadingFriendly , spawn_type=myFriendlySpawnType, skill = gFriendlySkillLevel  , type=myFriendlyTargets.type, position=myUnitPosition  , alt=myFriendlyAlt , speed=myEnemyTargets.speed, altType="RADIO", }
			if myFriendlySpawnType==Group.Category.AIRPLANE or myFriendlySpawnType == Group.Category.HELICOPTER then 
				myUnits[#myUnits].payload = myFriendlyPayload 		
			end
		end
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name=input.group .. "C" .. gTargetsCount .. "GF" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gFriendlySkillLevel , action= "Off Road" , waypoints=myWaypoints, lateActivation=true , spawn_type=myFriendlySpawnType, type=myFriendlyTargets.type, position=myFriendlyGroupPosition , heading=myHeadingFriendly , country=input.friendlycountry , speed=myFriendlyTargets.speed , alt=myFriendlyAlt , altType="RADIO", tasks=myFriendlyTask, }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.friendlycountryid, myFriendlySpawnType , myBuiltSpawn )
		myFriendlyGroups[#myFriendlyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
	end
		
	local myTargetName = "Enemy " ..  gTargetsCount

	
	local myHiddenGroups = {}
	local myFriendlyTriggers = {}
	local myEnemyTriggers = {}
	for key , value in pairs(myEnemyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
		myEnemyTriggers[#myEnemyTriggers+1] = value
	end
	for key , value in pairs(myFriendlyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
		myFriendlyTriggers[#myFriendlyTriggers+1] = value
	end
	
	local myPlayerGroups = {[1]={name=input.group,type=gPlayerGroups[input.group].type}}
	local myMessages =	{[1]="flyheading" , [2]="protect_friendy", [3]="clearedtofire",}
	local myTriggers = {[1]={groups=myPlayerGroups, atgroup=myFriendlyGroups[1].name} , -- group near atgroup or atpoint
						[2]={groups=myFriendlyGroups , atpoint=myStartingPosition.position , directto=myFriendlyGroups }, -- override normal direction of at group
						-- [2]={groups=myFriendlyGroups , atpoint=myEnemyAirport.point , directto=myFriendlyGroups }, -- override normal direction of at group
						[3]={groups=myPlayerGroups, atgroup=myEnemyGroups[1].name} , 
						}

	local myHiddenTargets = {[1]=myFriendlyGroups , [2]=myEnemyGroups ,}	
			
	gTargets[input.group] = { name=input.group, target=myTargetName , groups=myEnemyGroups, friendlygroups=myFriendlyGroups , startpoint=myStartPoint, activated=false ,  menu=input.menu, 
	typename=myTypename, key=myEnemyTargets.key,  missiontype=gSayThis[myLanguage].protect_friendy , 
	triggers=myTriggers, messages=myMessages , phrasecount=1}
	
	-- gHiddenTargets[input.group] = { name=input.group, target=myTargetName , groups=myHiddenGroups ,  menu=input.menu ,}
	gHiddenTargets[input.group] = { name=input.group,  groups=myHiddenTargets , triggers=myTriggers , menu=input.menu }

	--gLocationTriggers[input.group] = { name=input.group, target=myTargetName , groups=myEnemyGroups , friendlygroups=myFriendlyGroups , enemytrigger=myEnemyAirport.point , friendlytrigger=myFriendlyPosition,}
	
	gMissionsRunning[input.group] = { name=input.group, friendlycountry=input.friendlycountry , friendlycountryid=input.friendlycountryid, group=input.group,  menu=input.menu , typename=myTypename , groups = myEnemyGroups , friendlygroups = myFriendlyGroups, startpoint=myStartPoint }
			
	-- doInstructPlayers ( {group=input.group} )
	doInstructPlayers ( {group=input.group} )
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
		
end 
function mission_CombatAirPatrol ( input )
	removeActiveMissions ( {group=input.group , } )
	gTargetsCount = gTargetsCount + 1
	local myEnemyGroups = {}
	local myFriendlyGroups = {}
	local myDistanceBetweenForces = 1000
	local myDistanceFromObjective = 18000
	local myFlightTimeBetweenForces = 1 -- in minutes
	local myDriveTimeBetweenForces = 1 -- in minutes
	
	local myUnitEnemyCounts = 3
	local myGroupEnemyCounts = 1
	local myGroupEnemyAirCoverCounts = 3
	local myUnitEnemyAirCoverCounts = 2
	local myUnitFriendlyCounts = 4
	local myGroupFriendlyCounts = 2
	
	local myUnitEnemyAirCoverUnhides = 1 -- how many the initial unhide shows

	
	local myFriendlyUnitSpaced = 10
	local myEnemyUnitSpaced = 10
	local myFriendlyGroupSpaced = 10
	local myEnemyGroupSpaced = 10
	local myFriendlyName = "FG"
	local myEscortDistance = math.random ( 10 , 12 )*1000
	local myRandomDistance = gPlayerGroups[input.group].preferences.targetrange + (math.random ( 3 , 10 )*1000) 
	
	local myRandomMissionTypes = {[1]="ground" , [2]="airborne"}
	
	local myMissionChoice = ""
	if input.settings == myRandomMissionTypes[1] then myMissionChoice = myRandomMissionTypes[1] end 
	if input.settings == myRandomMissionTypes[2] then myMissionChoice = myRandomMissionTypes[2] end
	-- local myMissionChoice = myRandomMissionTypes[math.random(1,#myRandomMissionTypes)]
	-- local myMissionChoice = myRandomMissionTypes[1]

	local mySurfaceWater = {[1]="Water" ,} 
	local mySurfaceLand = {[1]="Land" ,} 
	local mySurfaceMixed = {[1]="Water" ,[2]="Land" ,}
	-- GET PLAYER AIRCRAFT TYPE INFORMATION
	input.enterservice = gPlayerGroups[input.group].enterservice
	input.retired = gPlayerGroups[input.group].retired
	input.country = gPlayerGroups[input.group].historicalcountry
	input.accurate = gPlayerGroups[input.group].preferences.historicalaccurate
	input.playerspeed = Targets[gPlayerGroups[input.group].key].speed*.75
	local myLanguage = gPlayerGroups[input.group].preferences.language
	
	-- CHANGE OUR TARGET TYPES SHIPPING
	input.medium=MissionCombat.ARMORED.combat -- TARGET TYPES
	local myFriendlyCategory = MissionCombat.ARMORED
	local myFriendlySpawnType=Group.Category.GROUND
	if myMissionChoice == "airborne" then
		myFriendlyCategory = MissionCombat.FIGHTER
		myFriendlySpawnType=Group.Category.AIRPLANE
		myRandomDistance = myRandomDistance + myEscortDistance
	end 
	
	local myEnemyCategory = MissionCombat.ARMORED
	local myEnemySpawnType=Group.Category.GROUND


	input.action = "Fly Over Point"
	local myFriendlyAction = "On Road"
	local myFriendlyCountry = Targets[gPlayerGroups[input.group].key].country -- FRIENDLY WILL END UP BEING OPPOSING SIDE OF PLAYERS


	-- CHANGE OUR TARGET TYPES AIRBORNE
	-- local myFriendlyCategory = MissionCombat.BOMBER
	-- local myEnemyCategory = MissionCombat.FIGHTER
	-- local myEnemySpawnType=Group.Category.AIRPLANE
	-- local myFriendlySpawnType=Group.Category.AIRPLANE
	-- input.action = "Turning Point"
	-- myFriendlyCountry = Targets[gPlayerGroups[input.group].key].country -- FRIENDLY WILL END UP BEING OPPOSING SIDE OF ENEMY
	
	-- GET A ENEMY GROUND TARGET TYPE
	input.country = Targets[gPlayerGroups[input.group].key].country
	
	input.mission = myEnemyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET 
	local myEnemyTargets=myTargets[math.random( 1, #myTargets )] 
	myEnemyTargets.key = string.upper(myEnemyTargets.type:gsub('[%p%c%s]', '') )
	
	-- GET A ENEMY AIRCOVER TYPE
	input.mission = MissionCombat.FIGHTER
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET 
	local myEnemyAircover=myTargets[math.random( 1, #myTargets )] 
	myEnemyAircover.key = string.upper(myEnemyAircover.type:gsub('[%p%c%s]', '') )
	
	local myEnemyPayload = {}
	if myEnemySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myEnemyPayload  = {  ["fuel"] = myEnemyAircover.fuel , ["pylons"] = myEnemyAircover.gpylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 } 
		if myEnemyAircover.enterservice <= 1958 then 
			myEnemyPayload.flare = 0 
			myEnemyPayload.chaff = 0 
		end 
	end
	
	
	-- CHANGE GET A FRIENDLY TARGET TYPE 
	--input.country = myFriendlyCountry -- country is opposite of enemy for both to be opposite of group ( ships , etc )
	input.country = Targets[myEnemyTargets.key].country --friendly is same country as human group aircraft type
	
	--GET A FRIENDLY TARGET TYPE 
	input.mission = myFriendlyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET
	local myFriendlyTargets=myTargets[math.random( 1, #myTargets )] 
	myFriendlyTargets.key = string.upper(myFriendlyTargets.type:gsub('[%p%c%s]', '') )
	myFriendlyTargets.speed = myFriendlyTargets.speed*.75
	local myFriendlyPayload = {}
	if myFriendlySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myFriendlyPayload  = {  ["fuel"] = myFriendlyTargets.fuel , ["pylons"] = myFriendlyTargets.gpylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 }
		if myFriendlyTargets.enterservice <= 1958 then 
			myFriendlyPayload.flare = 0 
			myFriendlyPayload.chaff = 0 
		end 
	end 	

	
	-- CHANGE FIND THE CLOSEST GROUND TARGET
	input.alt = 0
	local myTypename = input.menu .. " " .. gSayThis[myLanguage].protect_friendy
	local myFriendlyAlt = 0
	local myEnemyAlt = 0
	local myPrecision = 10 -- how big the water and land must be to decide on it
	local myEnemyGroupSpaced = 100
	local myEnemyUnitSpaced = 20


	local myUnit1 = Group.getByName(input.group):getUnit(1)
	local myUnitName = Unit.getName (myUnit1)
	local myUnit1Heading = doGetUnitHeading ({callsign=myUnitName})



	local myStartingPosition = findMatchingSurfacePoints ( {unit=Unit.getName(Group.getByName(input.group):getUnit(1)) ,surfacetypes=mySurfaceLand, distance=myRandomDistance , samples=12, precision=myPrecision } )
	myStartingPosition.position.x, myStartingPosition.position.z = land.getClosestPointOnRoads('roads' , myStartingPosition.position.x, myStartingPosition.position.z )

	
	
	
	local myEndingPosition = findMatchingSurfacePoints ( {position=myStartingPosition.position ,surfacetypes=mySurfaceLand, distance=myDistanceBetweenForces , samples=15, precision=myPrecision } )
	local myEnemyPosition = myStartingPosition.position -- MAKE IS SIMPLIER BECAUSE WE RETURN A TABLE
	local myFriendlyPosition = myEndingPosition.position -- MAKE IS SIMPLIER BECAUSE WE RETURN A TABLE
	local myFriendlyWaypoint = myEnemyPosition
	-- CHANGE WHICH WAY ARE FORCES HEADING
	local myHeadingEnemy = getBearingTwoPoints(myEnemyPosition , myFriendlyPosition )
	local myHeadingFriendly = getBearingTwoPoints(  myFriendlyPosition, myEnemyPosition )


	local myFriendlyTask = {}
	if myMissionChoice == "airborne" then	
		local myFriendlyAngle = getAngleBetweenTwoPointsV2(Unit.getPoint(myUnit1) , myStartingPosition.position)
		myHeadingFriendly = getBearingTwoPoints(Unit.getPoint(myUnit1) , myStartingPosition.position)
		myFriendlyPosition = getPointOnRadian ( { diameter=myEscortDistance*2 , pos=Unit.getPoint(myUnit1) , angle=myFriendlyAngle })
		myFriendlyTask = formation.WWIIFighterOpen
		myFriendlyTask[2] = {["number"] = 2,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargetsInZone', params = { point = {x=myEnemyPosition.x, y=myEnemyPosition.z },  zoneRadius  = 40000 ,targetTypes = {[1] = "All",}, priority = 0 , } }
		myFriendlyTask[3] = {["number"] = 3,["auto"] = true , ["enabled"] = true, ["id"] = "ControlledTask",  params = {["task"] =  { ["id"] = "WrappedAction", ["params"] = {["action"] = { ["id"] = "Option",["params"] = {["value"] = true,["name"] = 15,},}, }, }, ["condition"] = {}, }, }
		myFriendlyTask[4] = {["number"] = 4,["auto"] = true , ["enabled"] = true, ["id"] = "ControlledTask",  params = {["task"] =  { ["id"] = "WrappedAction", ["params"] = {["action"] = { ["id"] = "Option",["params"] = {["value"] = true,["name"] = 14,},}, }, }, ["condition"] = {}, }, }
		myFriendlyAction = "Fly Over Point"
		myFriendlyAlt = FindMaxTerrainBetweenPoints ( {point1=myFriendlyPosition, point2=myEnemyPosition} ) 
		myFriendlyAlt = (myFriendlyAlt + ((math.random(5,10)*1000)*FEET_TO_METERS)) * FEET
		myFriendlyGroupSpaced = 30
		myEnemyPayload["pylons"] = myFriendlyTargets.pylons -- switch to air to air pylons
		myFriendlyName = "FF"
		--myFriendlyAlt = getMSLfeet(myUnitName) - 500
	end 
	local myStartPoint = myFriendlyPosition -- POSITION TO DIRECT THE PLAYER TO FLY TOWARDS
	
	-- CREATE THE ENEMY AIRCOVER

	-- local myEnemyAircoverTask = formation.WWIIFighterOpen -- formation always comes first in task list or will crash game
	local myEnemyAircoverGroups = {}
	local myEnemyAircoverTask = formation.WWIIFighterOpen
	myEnemyAircoverTask[2] = {["number"] = 2,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargets', params = { maxDistEnabled = true, maxDist = 40000 ,targetTypes = {[1] = "All",}, noTargetTypes = {}, priority = 0 , } }
	--myEnemyAircoverTask[3] = {["number"] = 3,["auto"] = true , ["enabled"] = true, ["id"] = "ControlledTask",  	   params = {["task"] =  { ["id"] = "WrappedAction", ["params"] = {["action"] = { ["id"] = "Option",["params"] = {["value"] = true,["name"] = 15,},}, }, }, ["condition"] = {}, }, }

	for groups = 1, myGroupEnemyAirCoverCounts do
		local myEnemyAircoverPosition = getPointOnRadian ( { diameter=(math.random(10,20)*1000 ) , pos=myFriendlyPosition , angle = math.random(1,6) })
		local myAircoverAlt = (math.random(5,7)*1000 ) 
		local myAircoverHeading = getBearingTwoPoints(myEnemyAircoverPosition , myFriendlyPosition )
		local myEnemyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyGroupSpaced)*groups , pos=myEnemyAircoverPosition , angle = math.random(1,6) })
		local myTerrainAlt = FindMaxTerrainBetweenPoints ( {point1=myEnemyGroupPosition, point2=myFriendlyPosition} )
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = input.action, pos=myEnemyPosition , alt = myAircoverAlt+(myTerrainAlt*FEET) , altType="BARO" , speed = myEnemyAircover.speed , }
		local myUnits = {}
		for units = 1, myUnitEnemyAirCoverCounts do
			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyUnitSpaced) , pos=myEnemyGroupPosition , angle = math.random(1,6) })
			myUnits[#myUnits+1] = { name = "EF" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading=myAircoverHeading,  livery_id=myEnemyAircover.rlivery, spawn_type=Group.Category.AIRPLANE , payload = myEnemyPayload, skill = gEnemySkillLevel  , type=myEnemyAircover.type, position=myUnitPosition  , alt=myAircoverAlt+(myTerrainAlt*FEET)  , speed=myEnemyAircover.speed, altType="BARO", }
		end
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "EF" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gEnemySkillLevel , action= input.action , waypoints=myWaypoints, lateActivation=true , spawn_type=Group.Category.AIRPLANE , type=myEnemyAircover.type, position=myEnemyGroupPosition , heading=myAircoverHeading, country=input.enemycountry , speed=myEnemyAircover.speed , alt=myAircoverAlt+(myTerrainAlt*FEET)  , altType="BARO", tasks=myEnemyAircoverTask,}
		local myBuiltSpawn = doBuildSpawn (mySpawn)
				
		coalition.addGroup(input.enemycountryid, Group.Category.AIRPLANE, myBuiltSpawn ) 
		myEnemyAircoverGroups[#myEnemyAircoverGroups+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true ,} --friendly in the group triggers enemy not players 
		local myNextSpawnName = "EF" .. gTargetsCount .. "G" .. (groups+1)
		myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true ,   } --friendly in the group triggers enemy not players  		
		if groups > myUnitEnemyAirCoverUnhides then myEnemyGroups[#myEnemyGroups].killregenerates = true end -- HIDE THESE OTHERS TO PREVENT STUDDER ON UNMASK DURING FIGHT
		if groups < myGroupEnemyAirCoverCounts then 
			myEnemyGroups[#myEnemyGroups].nextspawn = myNextSpawnName 
			myEnemyGroups[#myEnemyGroups].respawn=mySpawn
		end -- HIDE THESE OTHERS TO PREVENT STUDDER ON UNMASK DURING FIGHT
		--myEnemyGroups[#myEnemyGroups].nextspawn = myNextSpawnName  -- THE LAST MEMBER OF THE GROUP WON'T RESPAWN
	end
	
		-- --- CREATE THE ENEMY GROUND TARGET
	local myRespawnRequired = {}
	local myGroundEnemyGroup = {}
	for groups = 1, myGroupEnemyCounts do
		local myEnemyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyGroupSpaced) , pos=myEnemyPosition , angle = math.random(1,6) })
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = "On Road" , pos=myFriendlyPosition , alt = myEnemyAlt  , altType="RADIO" , speed = myEnemyTargets.speed , }
		local myUnits = {}
		for units = 1, myUnitEnemyCounts do
			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyUnitSpaced) , pos=myEnemyGroupPosition , angle = math.random(1,6) })
			myUnits[#myUnits+1] = { name = "EG" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading=myHeadingEnemy, spawn_type=myEnemySpawnType , skill = gEnemySkillLevel  , type=myEnemyTargets.type, position=myUnitPosition  , alt=myEnemyAlt , speed=myEnemyTargets.speed, altType="RADIO", }
			if myEnemySpawnType == Group.Category.AIRPLANE or myEnemySpawnType == Group.Category.HELICOPTER then myUnits[#myUnits].payload = myEnemyPayload  end
		end
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "EG" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gEnemySkillLevel , action= "On Road" , waypoints=myWaypoints, lateActivation=true , spawn_type=myEnemySpawnType , type=myEnemyTargets.type, position=myEnemyGroupPosition , heading=myHeadingEnemy, country=input.enemycountry , speed=myEnemyTargets.speed , alt=myEnemyAlt , altType="RADIO", tasks=myEnemyTask,}
		myRespawnRequired[mySpawn.name] =  mySpawn.name 
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.enemycountryid, myEnemySpawnType, myBuiltSpawn ) 
		myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true,} --friendly in the group triggers enemy not players  
		myGroundEnemyGroup[#myGroundEnemyGroup+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true,} --friendly in the group triggers enemy not players 
	end 
	
	-- CREATE THE FRIENDLY TARGET
	for groups = 1, myGroupFriendlyCounts do
		local myFriendlyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyGroupSpaced) , pos=myFriendlyPosition , angle = math.random(1,6) })
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = myFriendlyAction , pos=myFriendlyWaypoint , alt = myFriendlyAlt  , altType="BARO" , speed =myFriendlyTargets.speed ,  }
		local myUnits = {}
		for units = 1, myUnitFriendlyCounts do
			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyUnitSpaced) , pos=myFriendlyGroupPosition , angle = math.random(1,6) })
			myUnits[#myUnits+1] = { name = myFriendlyName .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading = myHeadingFriendly , spawn_type=myFriendlySpawnType, skill = gFriendlySkillLevel  , type=myFriendlyTargets.type, position=myUnitPosition  , alt=myFriendlyAlt , speed=myFriendlyTargets.speed, altType="BARO", }
			if myFriendlySpawnType==Group.Category.AIRPLANE or myFriendlySpawnType == Group.Category.HELICOPTER then 
				myUnits[#myUnits].payload = myFriendlyPayload 	
				myUnits[#myUnits].livery_id=myFriendlyTargets.blivery 
			end
		end
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = myFriendlyName .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gFriendlySkillLevel , action= myFriendlyAction , waypoints=myWaypoints, lateActivation=true , spawn_type=myFriendlySpawnType, type=myFriendlyTargets.type, position=myFriendlyGroupPosition , heading=myHeadingFriendly , country=input.friendlycountry , speed=0, alt=myFriendlyAlt , altType="BARO", tasks=myFriendlyTask, }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.friendlycountryid, myFriendlySpawnType , myBuiltSpawn )
		myFriendlyGroups[#myFriendlyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
	end	

	
	local myTargetName = "Enemy " ..  gTargetsCount
	local myHiddenGroups = {}
	--local myFriendlyTriggers = {}
	local myEnemyTriggers = {}
	
	-- WANT THEM ALL TO SPAWN AT SAME TIME PUT IN HIDDEN GROUPS
	for key , value in pairs(myEnemyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
	--	myEnemyTriggers[#myEnemyTriggers+1] = value
	end
	for key , value in pairs(myFriendlyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
	--	myFriendlyTriggers[#myFriendlyTriggers+1] = value
	end
	
	local myPlayerGroups = {[1]={name=input.group,type=gPlayerGroups[input.group].type}}
	local myMessages =	{[1]="flyheading" , [2]="protect_friendy", [3]="clearedtofire",}
	
	local myTriggers = {[1]={groups=myPlayerGroups, atgroup=myFriendlyGroups[1].name} , -- group near atgroup or atpoint
						[2]={groups=myFriendlyGroups, atgroup=myGroundEnemyGroup[1].name , directto=myFriendlyGroups },
						[3]={groups=myPlayerGroups, atgroup=myEnemyGroups[1].name, directto=myEnemyAircoverGroups} , 
						}

	local myHiddenTargets = {[1]=myFriendlyGroups , [2]=myEnemyGroups ,}
	
	gTargets[input.group] = { name=input.group, target=myTargetName , groups=myEnemyGroups, friendlygroups=myFriendlyGroups , startpoint=myStartPoint, activated=false ,  menu=input.menu, 
	typename=myTypename, key=myFriendlyTargets.key,  missiontype=gSayThis[myLanguage].destroy_enemy , 
	triggers=myTriggers, messages=myMessages , phrasecount=1, required=myRespawnRequired }
	
	gHiddenTargets[input.group] = { name=input.group,  groups=myHiddenTargets , triggers=myTriggers , menu=input.menu }
	
	-- gLocationTriggers[input.group] = { name=input.group, triggers=myLocationTriggers ) 
	
	gMissionsRunning[input.group] = { name=input.group, friendlycountry=input.friendlycountry , friendlycountryid=input.friendlycountryid, group=input.group,  menu=input.menu , typename=myTypename , groups = myEnemyGroups , friendlygroups = myFriendlyGroups, startpoint=myStartPoint }
			
	-- doInstructPlayers ( {group=input.group} )
	doInstructPlayers ( {group=input.group} )
	
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
	
	
end 
-- MISSIONS NAVAL --
function mission_Wolfpack ( input )
	removeActiveMissions ( {group=input.group , } )
	gTargetsCount = gTargetsCount + 1
	local myEnemyGroups = {}
	local myFriendlyGroups = {}
	local myDistanceBetweenForces = 3000
	local myDistanceFromObjective = 18000
	local myFlightTimeBetweenForces = 1 -- in minutes
	local myDriveTimeBetweenForces = 1 -- in minutes
	local myUnitEnemyCounts = 3
	local myGroupEnemyCounts = 1
	local myUnitFriendlyCounts = 4
	local myGroupFriendlyCounts = 1
	local myFriendlyUnitSpaced = 200
	local myEnemyUnitSpaced = 200
	local myFriendlyGroupSpaced = 500
	local myEnemyGroupSpaced = 500

	local mySurfaceWater = {[1]="Water" ,} 
	local mySurfaceLand = {[1]="Land" ,} 
	local mySurfaceMixed = {[1]="Water" ,[2]="Land" ,}
	-- GET PLAYER AIRCRAFT TYPE INFORMATION
	input.enterservice = gPlayerGroups[input.group].enterservice
	input.retired = gPlayerGroups[input.group].retired
	input.country = gPlayerGroups[input.group].historicalcountry
	input.accurate = gPlayerGroups[input.group].preferences.historicalaccurate
	input.playerspeed = Targets[gPlayerGroups[input.group].key].speed*.75
	local myLanguage = gPlayerGroups[input.group].preferences.language
	
	-- OUR TARGET TYPES SHIPPING
	input.medium=MissionCombat.SUBMARINE.combat -- TARGET TYPES
	local myFriendlyCategory = MissionCombat.CARGOSHIP
	local myEnemyCategory = MissionCombat.SUBMARINE
	local myEnemySpawnType=Group.Category.SHIP
	local myFriendlySpawnType=Group.Category.SHIP
	input.action = "Turning Point"
	local myFriendlyCountry = Targets[gPlayerGroups[input.group].key].country -- FRIENDLY WILL END UP BEING OPPOSING SIDE OF PLAYERS


	-- CHANGE OUR TARGET TYPES AIRBORNE
	-- local myFriendlyCategory = MissionCombat.BOMBER
	-- local myEnemyCategory = MissionCombat.FIGHTER
	-- local myEnemySpawnType=Group.Category.AIRPLANE
	-- local myFriendlySpawnType=Group.Category.AIRPLANE
	-- input.action = "Turning Point"
	-- myFriendlyCountry = Targets[gPlayerGroups[input.group].key].country -- FRIENDLY WILL END UP BEING OPPOSING SIDE OF ENEMY
	
	-- GET A ENEMY TARGET TYPE
	input.country = Targets[gPlayerGroups[input.group].key].country
	
	input.mission = myEnemyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET 
	local myEnemyTargets=myTargets[math.random( 1, #myTargets )] 
	myEnemyTargets.key = string.upper(myEnemyTargets.type:gsub('[%p%c%s]', '') )
	
	local myEnemyPayload = {}
	if myEnemySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myEnemyPayload  = {  ["fuel"] = myEnemyTargets.fuel , ["pylons"] = myEnemyTargets.pylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 } 
		if myEnemyTargets.enterservice <= 1958 then 
			myEnemyPayload.flare = 0 
			myEnemyPayload.chaff = 0 
		end 
	end
	
	-- CHANGE GET A FRIENDLY TARGET TYPE 
	input.country = myFriendlyCountry -- country is opposite of enemy for both to be opposite of group ( ships , etc )
	--input.country = Targets[myEnemyTargets.key].country --friendly is same country as human group aircraft type
	
	--GET A FRIENDLY TARGET TYPE 
	input.mission = myFriendlyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET
	local myFriendlyTargets=myTargets[math.random( 1, #myTargets )] 
	myFriendlyTargets.key = string.upper(myFriendlyTargets.type:gsub('[%p%c%s]', '') )
	local myFriendlyPayload = {}
	if myFriendlySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myFriendlyPayload  = {  ["fuel"] = myFriendlyTargets.fuel , ["pylons"] = myFriendlyTargets.gpylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 }
		if myFriendlyTargets.enterservice <= 1958 then 
			myFriendlyPayload.flare = 0 
			myFriendlyPayload.chaff = 0 
		end 
	end 	

	-- CHANGE FIND CLOSEST ENEMY AIRPORT
	-- input.alt = 0
	-- local myTypename = myFriendlyTargets.category .. " " .. input.menu
	-- local myUnitName = Unit.getName(Group.getByName(input.group):getUnit(1))
	-- local myPosition = centerUnitCoordinates (myUnitName)
	-- local myEnemyAirport = findClosestAirbase ({position=myPosition ,coalition=input.friendlycoa })
	-- local myEnemyPosition = getPointOnRadian ( { diameter=myDistanceBetweenForces , pos=myEnemyAirport.point , angle = myEnemyAirport.angle+math.pi })
	-- local myFriendlyPosition = getPointOnRadian ( { diameter=0 , pos=myEnemyAirport.point , angle = myEnemyAirport.angle })
	-- local myFriendlyWaypoint = myEnemyPosition
	
	-- CHANGE FIND THE CLOSEST WATER TARGET
	input.alt = 0
	local myTypename = myFriendlyTargets.category .. " " .. input.menu
	local myFriendlyAlt = 0
	local myEnemyAlt = 0
	local myPrecision = 1000 -- how big the water and land must be to decide on it
	local myFriendlyGroupSpaced = 1000
	local myEnemyGroupSpaced = 1000
	local myFriendlyUnitSpaced = 1000
	local myEnemyUnitSpaced = 1000
	myDistanceBetweenForces = ((input.playerspeed/3600)*(myFlightTimeBetweenForces*120))*MILES_TO_METERS
	--local myGroupPosition = centerUnitCoordinates (Unit.getName(Group.getByName(input.group):getUnit(1))) -- GET THE POSITION OF WHOEVER IS NUMBER 1
	local myRandomDistance = gPlayerGroups[input.group].preferences.targetrange + (math.random ( 3 , 10 )*1000)
	local myStartingPosition = findMatchingSurfacePoints ( {unit=Unit.getName(Group.getByName(input.group):getUnit(1)) ,surfacetypes=mySurfaceWater, distance=myRandomDistance , samples=12, precision=myPrecision } )
	local myEndingPosition = findMatchingSurfacePoints ( {position=myStartingPosition.position ,surfacetypes=mySurfaceWater, distance=myDistanceBetweenForces , samples=15, precision=myPrecision } )
	local myEnemyPosition = myStartingPosition.position -- MAKE IS SIMPLIER BECAUSE WE RETURN A TABLE
	local myFriendlyPosition = myEndingPosition.position -- MAKE IS SIMPLIER BECAUSE WE RETURN A TABLE
	local myFriendlyWaypoint = myEnemyPosition

	
	--CHANGE FIND THE CLOSEST AIRBORNE TARGET
	-- local myTypename = 	myFriendlyTargets.type .. " " .. input.menu
	-- local myPrecision = 50 -- how big the water and land must be to decide on it
	-- myDistanceBetweenForces = ((myEnemyTargets.speed/3600)*(myFlightTimeBetweenForces*60))*MILES_TO_METERS
	-- local myPlayersAlt = GetAltitudeRangesGroup ( { group=input.group, } )
	-- local myFriendlyAlt = myPlayersAlt.average_msl + math.random (5,10)*1000
	-- local myEnemyAlt = myFriendlyAlt -- + math.random (2,4)*1000
	-- local myFriendlyAngle = math.random(1,6)
	-- local myEnemyAngle = myFriendlyAngle+(math.pi/2) - (math.random(0,5)*(math.pi/5))
	-- local myEnemyAirport = findClosestAirbase ({position=centerUnitCoordinates (Unit.getName(Group.getByName(input.group):getUnit(1))) ,coalition=input.enemycoa })
	-- local myFriendlyPosition = getPointOnRadian ( { diameter=myDistanceFromObjective*2 , pos=myEnemyAirport.point , angle=myFriendlyAngle })
	-- local mFriendlyAirport = findClosestAirbase ({position=myEnemyAirport.point ,coalition=input.friendlycoa })
	-- local myFriendlyWaypoint = mFriendlyAirport.point
	-- local myEnemyPosition = getPointOnRadian ( { diameter=myDistanceBetweenForces , pos=myEnemyAirport.point  , angle = myEnemyAngle })
	-- local myBombingPoint = {x=myEnemyAirport.point.x , y=myEnemyAirport.point.z} 
	-- local myEnemyTask = formation.WWIIFighterOpen -- formation always comes first in task list or will crash game
	-- myEnemyTask[2] = {["number"] = 2,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargets', params = { maxDistEnabled = true, maxDist = 100000 ,targetTypes = {[1] = "All",}, noTargetTypes = {}, priority = 0 , } }
	-- local myFriendlyTask =	formation.WWIIBomberTight -- formation always comes first in task list or will crash game
	-- myFriendlyTask[2] = {["number"] = 2,["auto"] = false,["id"] = 'CarpetBombing', params = {  point = myBombingPoint, attackQtyLimit = false, attackType = "Carpet", weaponType = 2147485694 , expend = "All", attackQty = 1, groupAttack = true, altitude = myFriendlyAlt*FEET_TO_METERS, altitudeEnabled = true, } } 
	


	-- CHANGE WHICH WAY ARE FORCES HEADING
	local myHeadingEnemy = getBearingTwoPoints(myEnemyPosition , myFriendlyPosition )
	local myHeadingFriendly = getBearingTwoPoints(  myFriendlyPosition, myEnemyPosition )
	local myStartPoint = myFriendlyPosition -- POSITION TO DIRECT THE PLAYER TO FLY TOWARDS

--- CREATE THE ENEMY TARGET
	for groups = 1, myGroupEnemyCounts do
		local myEnemyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyGroupSpaced) , pos=myEnemyPosition , angle = math.random(1,6) })
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = input.action, pos=myFriendlyPosition , alt = myEnemyAlt  , altType="RADIO" , speed = myEnemyTargets.speed , }
		local myUnits = {}
		for units = 1, myUnitEnemyCounts do
			-- local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyUnitSpaced) , pos=myEnemyGroupPosition , angle = math.random(1,6) })
			local myUnitPosition = findMatchingSurfacePoints ( {position=myEnemyGroupPosition ,surfacetypes=mySurfaceWater, distance=(math.random(2,4)*myEnemyUnitSpaced) , samples=15, precision=myPrecision*2 } )
			myUnits[#myUnits+1] = { name = "E" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading=myHeadingEnemy,  spawn_type=myEnemySpawnType , skill = gEnemySkillLevel  , type=myEnemyTargets.type, position=myUnitPosition.position  , alt=myEnemyAlt , speed=myEnemyTargets.speed, altType="RADIO", }
			if myEnemySpawnType == Group.Category.AIRPLANE or myEnemySpawnType == Group.Category.HELICOPTER then myUnits[#myUnits].payload = myEnemyPayload  end
		end

		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "E" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gEnemySkillLevel , action= input.action , waypoints=myWaypoints, lateActivation=true , spawn_type=myEnemySpawnType , type=myEnemyTargets.type, position=myEnemyGroupPosition , heading=myHeadingEnemy, country=input.enemycountry , speed=myEnemyTargets.speed , alt=myEnemyAlt , altType="RADIO", tasks=myEnemyTask,}
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.enemycountryid, myEnemySpawnType, myBuiltSpawn ) 
		myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true} --friendly in the group triggers enemy not players  
	end 				
	
	-- CREATE THE FRIENDLY TARGET
	for groups = 1, myGroupFriendlyCounts do
		local myFriendlyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyGroupSpaced) , pos=myFriendlyPosition , angle = math.random(1,6) })
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = input.action , pos=myFriendlyWaypoint , alt = myFriendlyAlt  , altType="RADIO" , speed =myFriendlyTargets.speed ,  }
		local myUnits = {}
		for units = 1, myUnitFriendlyCounts do
			-- local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyUnitSpaced) , pos=myFriendlyGroupPosition , angle = math.random(1,6) })
			local myUnitPosition = findMatchingSurfacePoints ( {position=myFriendlyGroupPosition ,surfacetypes=mySurfaceWater, distance=(math.random(2,4)*myFriendlyUnitSpaced) , samples=15, precision=myPrecision } )
			myUnits[#myUnits+1] = { name = "F" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading = myHeadingFriendly , spawn_type=myFriendlySpawnType, skill = gFriendlySkillLevel  , type=myFriendlyTargets.type, position=myUnitPosition.position  , alt=myFriendlyAlt , speed=myFriendlyTargets.speed, altType="RADIO", }
			if myFriendlySpawnType==Group.Category.AIRPLANE or myFriendlySpawnType == Group.Category.HELICOPTER then 
				myUnits[#myUnits].payload = myFriendlyPayload 		
			end
		end
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "F" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gFriendlySkillLevel , action= input.action , waypoints=myWaypoints, lateActivation=true , spawn_type=myFriendlySpawnType, type=myFriendlyTargets.type, position=myFriendlyGroupPosition , heading=myHeadingFriendly , country=input.friendlycountry , speed=myFriendlyTargets.speed , alt=myFriendlyAlt , altType="RADIO", tasks=myFriendlyTask, }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.friendlycountryid, myFriendlySpawnType , myBuiltSpawn )
		myFriendlyGroups[#myFriendlyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
	end	

	local myTargetName = "Enemy " ..  gTargetsCount
	local myHiddenGroups = {}
	--local myFriendlyTriggers = {}
	local myEnemyTriggers = {}
	
	-- WANT THEM ALL TO SPAWN AT SAME TIME PUT IN HIDDEN GROUPS
	for key , value in pairs(myEnemyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
	--	myEnemyTriggers[#myEnemyTriggers+1] = value
	end
	for key , value in pairs(myFriendlyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
	--	myFriendlyTriggers[#myFriendlyTriggers+1] = value
	end
	
	local myPlayerGroups = {[1]={name=input.group,type=gPlayerGroups[input.group].type}}
	local myMessages =	{[1]="flyheading" , [2]="searcharea", [3]="clearedtofire",}
	local myTriggers = {[1]={groups=myPlayerGroups, atgroup=myFriendlyGroups[1].name} , -- group near atgroup or atpoint
						[2]={groups=myPlayerGroups, atgroup=myEnemyGroups[1].name},
						[3]={groups=myPlayerGroups, atgroup=myEnemyGroups[1].name} , 
						}

	local myHiddenTargets = {[1]=myFriendlyGroups , [2]=myEnemyGroups ,}
	
	gTargets[input.group] = { name=input.group, target=myTargetName , groups=myEnemyGroups, friendlygroups=myFriendlyGroups , startpoint=myStartPoint, activated=false ,  menu=input.menu, 
	typename=myTypename, key=myEnemyTargets.key,  missiontype=gSayThis[myLanguage].destroy_enemy , 
	triggers=myTriggers, messages=myMessages , phrasecount=1}
	
	gHiddenTargets[input.group] = { name=input.group,  groups=myHiddenTargets , triggers=myTriggers , menu=input.menu }
	
	-- gLocationTriggers[input.group] = { name=input.group, triggers=myLocationTriggers ) 
	
	gMissionsRunning[input.group] = { name=input.group, friendlycountry=input.friendlycountry , friendlycountryid=input.friendlycountryid, group=input.group,  menu=input.menu , typename=myTypename , groups = myEnemyGroups , friendlygroups = myFriendlyGroups, startpoint=myStartPoint }
			
	-- doInstructPlayers ( {group=input.group} )
	doInstructPlayers ( {group=input.group} )
	
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
	
	
end 
function mission_NavalConvoySpawn ( input )
	removeActiveMissions ( {group=input.group , } )
	gTargetsCount = gTargetsCount + 1
	local myEnemyGroups = {}
	local myFriendlyGroups = {}
	local myDistanceBetweenForces = 3000
	local myDistanceFromObjective = 18000
	local myFlightTimeBetweenForces = 1 -- in minutes
	local myDriveTimeBetweenForces = 1 -- in minutes
	local myUnitEnemyCounts = 2
	local myGroupEnemyCounts = 2
	local myUnitFriendlyCounts = 1
	local myGroupFriendlyCounts = 1
	local myGroupEnemyAirCoverCounts = 3
	local myUnitEnemyAirCoverCounts = 2
	local myFriendlyUnitSpaced = 200
	local myEnemyUnitSpaced = 200
	local myFriendlyGroupSpaced = 500
	local myEnemyGroupSpaced = 500
	
	local myUnitEnemyAirCoverUnhides = 1 -- how many the initial unhide shows


	local mySurfaceWater = {[1]="Water" ,} 
	local mySurfaceLand = {[1]="Land" ,} 
	local mySurfaceMixed = {[1]="Water" ,[2]="Land" ,}
	-- GET PLAYER AIRCRAFT TYPE INFORMATION
	input.enterservice = gPlayerGroups[input.group].enterservice
	input.retired = gPlayerGroups[input.group].retired
	input.country = gPlayerGroups[input.group].historicalcountry
	input.accurate = gPlayerGroups[input.group].preferences.historicalaccurate
	input.playerspeed = Targets[gPlayerGroups[input.group].key].speed*.75
	local myLanguage = gPlayerGroups[input.group].preferences.language
	
	-- OUR TARGET TYPES SHIPPING
	input.medium=MissionCombat.SUBMARINE.combat -- TARGET TYPES
	local myFriendlyCategory = MissionCombat.SUBMARINE
	local myEnemyCategory = MissionCombat.CARGOSHIP
	local myEnemySpawnType=Group.Category.SHIP
	local myFriendlySpawnType=Group.Category.SHIP
	input.action = "Turning Point"
	local myFriendlyCountry = Targets[gPlayerGroups[input.group].key].country -- FRIENDLY WILL END UP BEING OPPOSING SIDE OF PLAYERS



	-- CHANGE OUR TARGET TYPES AIRBORNE
	-- local myFriendlyCategory = MissionCombat.BOMBER
	-- local myEnemyCategory = MissionCombat.FIGHTER
	-- local myEnemySpawnType=Group.Category.AIRPLANE
	-- local myFriendlySpawnType=Group.Category.AIRPLANE
	-- input.action = "Turning Point"
	-- myFriendlyCountry = Targets[gPlayerGroups[input.group].key].country -- FRIENDLY WILL END UP BEING OPPOSING SIDE OF ENEMY
	
		-- GET A ENEMY AIRCOVER TYPE
	input.mission = MissionCombat.FIGHTER
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET 
	local myEnemyAircover=myTargets[math.random( 1, #myTargets )] 
	myEnemyAircover.key = string.upper(myEnemyAircover.type:gsub('[%p%c%s]', '') )
	
	local myEnemyPayload = {}
	if myEnemySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myEnemyPayload  = {  ["fuel"] = myEnemyAircover.fuel , ["pylons"] = myEnemyAircover.pylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 } 
		if myEnemyAircover.enterservice <= 1958 then 
			myEnemyPayload.flare = 0 
			myEnemyPayload.chaff = 0 
		end 
	end


	-- GET A ENEMY TARGET TYPE
	input.country = Targets[gPlayerGroups[input.group].key].country
	
	input.mission = myEnemyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET 
	local myEnemyTargets=myTargets[math.random( 1, #myTargets )] 
	myEnemyTargets.key = string.upper(myEnemyTargets.type:gsub('[%p%c%s]', '') )
	
	local myEnemyPayload = {}
	if myEnemySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myEnemyPayload  = {  ["fuel"] = myEnemyTargets.fuel , ["pylons"] = myEnemyTargets.pylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 } 
		if myEnemyTargets.enterservice <= 1958 then 
			myEnemyPayload.flare = 0 
			myEnemyPayload.chaff = 0 
		end 
	end
	
	-- CHANGE GET A FRIENDLY TARGET TYPE 
	input.country = myFriendlyCountry -- country is opposite of enemy for both to be opposite of group ( ships , etc )
	--input.country = Targets[myEnemyTargets.key].country --friendly is same country as human group aircraft type
	
	--GET A FRIENDLY TARGET TYPE 
	input.mission = myFriendlyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET	
	local myFriendlyTargets=myTargets[math.random( 1, #myTargets )] 
	myFriendlyTargets.key = string.upper(myFriendlyTargets.type:gsub('[%p%c%s]', '') )
	local myFriendlyPayload = {}
	if myFriendlySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myFriendlyPayload  = {  ["fuel"] = myFriendlyTargets.fuel , ["pylons"] = myFriendlyTargets.gpylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 }
		if myFriendlyTargets.enterservice <= 1958 then 
			myFriendlyPayload.flare = 0 
			myFriendlyPayload.chaff = 0 
		end 
	end 	

	-- CHANGE FIND CLOSEST ENEMY AIRPORT
	-- input.alt = 0
	-- local myTypename = myFriendlyTargets.category .. " " .. input.menu
	-- local myUnitName = Unit.getName(Group.getByName(input.group):getUnit(1))
	-- local myPosition = centerUnitCoordinates (myUnitName)
	-- local myEnemyAirport = findClosestAirbase ({position=myPosition ,coalition=input.friendlycoa })
	-- local myEnemyPosition = getPointOnRadian ( { diameter=myDistanceBetweenForces , pos=myEnemyAirport.point , angle = myEnemyAirport.angle+math.pi })
	-- local myFriendlyPosition = getPointOnRadian ( { diameter=0 , pos=myEnemyAirport.point , angle = myEnemyAirport.angle })
	-- local myFriendlyWaypoint = myEnemyPosition
	
	-- CHANGE FIND THE CLOSEST WATER TARGET
	input.alt = 0
	local myTypename = gSayThis[myLanguage].destroy_enemy .. " " ..  input.menu 
	local myFriendlyAlt = 0
	local myEnemyAlt = 0
	local myPrecision = 1000 -- how big the water and land must be to decide on it
	local myFriendlyGroupSpaced = 1000
	local myEnemyGroupSpaced = 1000
	local myFriendlyUnitSpaced = 1000
	local myEnemyUnitSpaced = 100
	myDistanceBetweenForces = ((input.playerspeed/3600)*(myFlightTimeBetweenForces*660))*MILES_TO_METERS
	--local myGroupPosition = centerUnitCoordinates (Unit.getName(Group.getByName(input.group):getUnit(1))) -- GET THE POSITION OF WHOEVER IS NUMBER 1
	local myRandomDistance = gPlayerGroups[input.group].preferences.targetrange + (math.random ( 3 , 10 )*1000)
	local myStartingPosition = findMatchingSurfacePoints ( {unit=Unit.getName(Group.getByName(input.group):getUnit(1)) ,surfacetypes=mySurfaceWater, distance=myRandomDistance , samples=12, precision=myPrecision } )
	local myEndingPosition = findMatchingSurfacePoints ( {position=myStartingPosition.position ,surfacetypes=mySurfaceWater, distance=myDistanceBetweenForces , samples=15, precision=myPrecision } )
	local myEnemyPosition = myStartingPosition.position -- MAKE IS SIMPLIER BECAUSE WE RETURN A TABLE
	local myFriendlyPosition = myEndingPosition.position -- MAKE IS SIMPLIER BECAUSE WE RETURN A TABLE
	local myFriendlyWaypoint = myEnemyPosition

	
	--CHANGE FIND THE CLOSEST AIRBORNE TARGET
	-- local myTypename = 	myFriendlyTargets.type .. " " .. input.menu
	-- local myPrecision = 50 -- how big the water and land must be to decide on it
	-- myDistanceBetweenForces = ((myEnemyTargets.speed/3600)*(myFlightTimeBetweenForces*60))*MILES_TO_METERS
	-- local myPlayersAlt = GetAltitudeRangesGroup ( { group=input.group, } )
	-- local myFriendlyAlt = myPlayersAlt.average_msl + math.random (5,10)*1000
	-- local myEnemyAlt = myFriendlyAlt -- + math.random (2,4)*1000
	-- local myFriendlyAngle = math.random(1,6)
	-- local myEnemyAngle = myFriendlyAngle+(math.pi/2) - (math.random(0,5)*(math.pi/5))
	-- local myEnemyAirport = findClosestAirbase ({position=centerUnitCoordinates (Unit.getName(Group.getByName(input.group):getUnit(1))) ,coalition=input.enemycoa })
	-- local myFriendlyPosition = getPointOnRadian ( { diameter=myDistanceFromObjective*2 , pos=myEnemyAirport.point , angle=myFriendlyAngle })
	-- local mFriendlyAirport = findClosestAirbase ({position=myEnemyAirport.point ,coalition=input.friendlycoa })
	-- local myFriendlyWaypoint = mFriendlyAirport.point
	-- local myEnemyPosition = getPointOnRadian ( { diameter=myDistanceBetweenForces , pos=myEnemyAirport.point  , angle = myEnemyAngle })
	-- local myBombingPoint = {x=myEnemyAirport.point.x , y=myEnemyAirport.point.z} 
	-- local myEnemyTask = formation.WWIIFighterOpen -- formation always comes first in task list or will crash game
	-- myEnemyTask[2] = {["number"] = 2,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargets', params = { maxDistEnabled = true, maxDist = 100000 ,targetTypes = {[1] = "All",}, noTargetTypes = {}, priority = 0 , } }
	-- local myFriendlyTask =	formation.WWIIBomberTight -- formation always comes first in task list or will crash game
	-- myFriendlyTask[2] = {["number"] = 2,["auto"] = false,["id"] = 'CarpetBombing', params = {  point = myBombingPoint, attackQtyLimit = false, attackType = "Carpet", weaponType = 2147485694 , expend = "All", attackQty = 1, groupAttack = true, altitude = myFriendlyAlt*FEET_TO_METERS, altitudeEnabled = true, } } 
	


	-- CHANGE WHICH WAY ARE FORCES HEADING
	local myHeadingEnemy = getBearingTwoPoints(myEnemyPosition , myFriendlyPosition )
	local myHeadingFriendly = getBearingTwoPoints(  myFriendlyPosition, myEnemyPosition )
	local myEnemyHeadingAngle = getAngleBetweenTwoPoints(myEnemyPosition , myFriendlyPosition )
	local myStartPoint = myEnemyPosition -- POSITION TO DIRECT THE PLAYER TO FLY TOWARDS
	
	local myRandomAngle = { [1]=math.pi , [2]= -math.pi }
	local myFriendlySublocation = getPointOnRadian ( { diameter=(math.random(2,3)*1000 ) , pos=myEnemyPosition , angle =myEnemyHeadingAngle+((myRandomAngle[math.random(1,2)])/2), })
	local myHeadingFriendly = getBearingTwoPoints(  myFriendlySublocation, myEnemyPosition )
-- CREATE THE ENEMY AIRCOVER

	-- local myEnemyAircoverTask = formation.WWIIFighterOpen -- formation always comes first in task list or will crash game
	local myEnemyAircoverGroups = {}
	local myEnemyAircoverTask = formation.WWIIFighterOpen
	myEnemyAircoverTask[2] = {["number"] = 2,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargets', params = { maxDistEnabled = true, maxDist = 40000 ,targetTypes = {[1] = "All",}, noTargetTypes = {}, priority = 0 , } }
	--myEnemyAircoverTask[3] = {["number"] = 3,["auto"] = true , ["enabled"] = true, ["id"] = "ControlledTask",  	   params = {["task"] =  { ["id"] = "WrappedAction", ["params"] = {["action"] = { ["id"] = "Option",["params"] = {["value"] = true,["name"] = 15,},}, }, }, ["condition"] = {}, }, }

	for groups = 1, myGroupEnemyAirCoverCounts do
		local myEnemyAircoverPosition = getPointOnRadian ( { diameter=(math.random(10,20)*1000 ) , pos=myEnemyPosition , angle = math.random(1,6) })
		local myAircoverAlt = (math.random(5,7)*1000 ) 
		local myAircoverHeading = getBearingTwoPoints(myEnemyAircoverPosition , myEnemyPosition )
		local myEnemyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyGroupSpaced)*groups , pos=myEnemyAircoverPosition , angle = math.random(1,6) })
		local myTerrainAlt = FindMaxTerrainBetweenPoints ( {point1=myEnemyGroupPosition, point2=myEnemyPosition} )
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = "Fly Over Point", pos=myEnemyPosition , alt = myAircoverAlt+(myTerrainAlt*FEET) , altType="BARO" , speed = myEnemyAircover.speed , }
		local myUnits = {}
		for units = 1, myUnitEnemyAirCoverCounts do
			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyUnitSpaced) , pos=myEnemyGroupPosition , angle = math.random(1,6) })
			myUnits[#myUnits+1] = { name = "EF" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading=myAircoverHeading,  livery_id=myEnemyAircover.rlivery, spawn_type=Group.Category.AIRPLANE , payload = myEnemyPayload, skill = gEnemySkillLevel  , type=myEnemyAircover.type, position=myUnitPosition  , alt=myAircoverAlt+(myTerrainAlt*FEET)  , speed=myEnemyAircover.speed, altType="BARO", }
		end
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "EF" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gEnemySkillLevel , action= "Fly Over Point" , waypoints=myWaypoints, lateActivation=true , spawn_type=Group.Category.AIRPLANE , type=myEnemyAircover.type, position=myEnemyGroupPosition , heading=myAircoverHeading, country=input.enemycountry , speed=myEnemyAircover.speed , alt=myAircoverAlt+(myTerrainAlt*FEET)  , altType="BARO", tasks=myEnemyAircoverTask,}
		local myBuiltSpawn = doBuildSpawn (mySpawn)
				
		coalition.addGroup(input.enemycountryid, Group.Category.AIRPLANE, myBuiltSpawn ) 
		myEnemyAircoverGroups[#myEnemyAircoverGroups+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true ,} --friendly in the group triggers enemy not players 
		local myNextSpawnName = "EF" .. gTargetsCount .. "G" .. (groups+1)
		myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true ,   } --friendly in the group triggers enemy not players  		
		if groups > myUnitEnemyAirCoverUnhides then myEnemyGroups[#myEnemyGroups].killregenerates = true end -- HIDE THESE OTHERS TO PREVENT STUDDER ON UNMASK DURING FIGHT
		if groups < myGroupEnemyAirCoverCounts then 
			myEnemyGroups[#myEnemyGroups].nextspawn = myNextSpawnName 
			myEnemyGroups[#myEnemyGroups].respawn=mySpawn
		end -- HIDE THESE OTHERS TO PREVENT STUDDER ON UNMASK DURING FIGHT
		--myEnemyGroups[#myEnemyGroups].nextspawn = myNextSpawnName  -- THE LAST MEMBER OF THE GROUP WON'T RESPAWN
	end


--- CREATE THE ENEMY TARGET
	local myRespawnRequired = {}
	local myEnemyShips = {}
	for groups = 1, myGroupEnemyCounts do
		local myEnemyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyGroupSpaced) , pos=myEnemyPosition , angle = math.random(1,6) })
		local myUnitPosition = getPointOnRadian ( { diameter=(3000*myUnitEnemyCounts), pos=myEnemyGroupPosition , angle = myEnemyHeadingAngle})
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = input.action, pos=myFriendlyPosition , alt = myEnemyAlt  , altType="RADIO" , speed = myEnemyTargets.speed , }
		local myUnits = {}
		for units = 1, myUnitEnemyCounts do
			local myUnitsRandomPosition = getPointOnRadian ( { diameter=math.random(1,3)*myEnemyUnitSpaced, pos=myUnitPosition.between[units] , angle = math.random(1,6)})			
			local myFinalPosition = findMatchingSurfacePoints ( {position=myUnitsRandomPosition,surfacetypes=mySurfaceWater, distance=100 , samples=12, precision=500 } )			
			myUnits[#myUnits+1] = { name = "E" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading=myHeadingEnemy,  spawn_type=myEnemySpawnType , skill = gEnemySkillLevel  , type=myEnemyTargets.type, position=myFinalPosition.position  , alt=myEnemyAlt , speed=myEnemyTargets.speed, altType="RADIO", }
			if myEnemySpawnType == Group.Category.AIRPLANE or myEnemySpawnType == Group.Category.HELICOPTER then myUnits[#myUnits].payload = myEnemyPayload  end
		end

		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "E" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gEnemySkillLevel , action= input.action , waypoints=myWaypoints, lateActivation=true , spawn_type=myEnemySpawnType , type=myEnemyTargets.type, position=myEnemyGroupPosition , heading=myHeadingEnemy, country=input.enemycountry , speed=myEnemyTargets.speed , alt=myEnemyAlt , altType="RADIO", tasks=myEnemyTask,}
		myRespawnRequired[mySpawn.name] =  mySpawn.name 
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.enemycountryid, myEnemySpawnType, myBuiltSpawn ) 
		myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true} --friendly in the group triggers enemy not players
		myEnemyShips[#myEnemyShips+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true} --friendly in the group triggers enemy not players  		
	end 				
	
	-- CREATE THE FRIENDLY TARGET
	for groups = 1, myGroupFriendlyCounts do
		local myFriendlyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyGroupSpaced) , pos=myFriendlySublocation , angle = math.random(1,6) })
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = input.action , pos=myFriendlyWaypoint , alt = myFriendlyAlt  , altType="RADIO" , speed =myFriendlyTargets.speed ,  }
		local myUnits = {}
		for units = 1, myUnitFriendlyCounts do
			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyUnitSpaced) , pos=myFriendlyGroupPosition , angle = math.random(1,6) })
			myUnits[#myUnits+1] = { name = "F" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading = myHeadingFriendly , spawn_type=myFriendlySpawnType, skill = gFriendlySkillLevel  , type=myFriendlyTargets.type, position=myUnitPosition  , alt=myFriendlyAlt , speed=myFriendlyTargets.speed, altType="RADIO", }
			if myFriendlySpawnType==Group.Category.AIRPLANE or myFriendlySpawnType == Group.Category.HELICOPTER then 
				myUnits[#myUnits].payload = myFriendlyPayload 		
			end
		end
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "F" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gFriendlySkillLevel , action= input.action , waypoints=myWaypoints, lateActivation=true , spawn_type=myFriendlySpawnType, type=myFriendlyTargets.type, position=myFriendlyGroupPosition , heading=myHeadingFriendly , country=input.friendlycountry , speed=myFriendlyTargets.speed , alt=myFriendlyAlt , altType="RADIO", tasks=myFriendlyTask, }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.friendlycountryid, myFriendlySpawnType , myBuiltSpawn )
		myFriendlyGroups[#myFriendlyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
	end	

	local myTargetName = "Enemy " ..  gTargetsCount
	local myHiddenGroups = {}
	--local myFriendlyTriggers = {}
	local myEnemyTriggers = {}
	
	-- WANT THEM ALL TO SPAWN AT SAME TIME PUT IN HIDDEN GROUPS
	for key , value in pairs(myEnemyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
	--	myEnemyTriggers[#myEnemyTriggers+1] = value
	end
	for key , value in pairs(myFriendlyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
	--	myFriendlyTriggers[#myFriendlyTriggers+1] = value
	end
	
	local myPlayerGroups = {[1]={name=input.group,type=gPlayerGroups[input.group].type}}
	local myMessages =	{[1]="flyheading" , [2]="searcharea", [3]="clearedtofire",}
	local myTriggers = {[1]={groups=myPlayerGroups, atgroup=myEnemyShips[1].name,} , -- group near atgroup or atpoint
						[2]={groups=myPlayerGroups, atgroup=myEnemyShips[1].name},
						[3]={groups=myPlayerGroups, atgroup=myEnemyGroups[1].name, directto=myEnemyAircoverGroups} ,
						}

	local myHiddenTargets = {[1]=myEnemyGroups  , [2]=myFriendlyGroups ,}
	
	gTargets[input.group] = { name=input.group, target=myTargetName , groups=myEnemyGroups, friendlygroups=myFriendlyGroups , startpoint=myStartPoint, activated=false ,  menu=input.menu, 
	typename=myTypename, key=myEnemyTargets.key,  missiontype=gSayThis[myLanguage].destroy_enemy , 
	triggers=myTriggers, messages=myMessages , phrasecount=1 , required=myRespawnRequired , }
	
	gHiddenTargets[input.group] = { name=input.group,  groups=myHiddenTargets , triggers=myTriggers , menu=input.menu }
	
	-- gLocationTriggers[input.group] = { name=input.group, triggers=myLocationTriggers ) 
	
	gMissionsRunning[input.group] = { name=input.group, friendlycountry=input.friendlycountry , friendlycountryid=input.friendlycountryid, group=input.group,  menu=input.menu , typename=myTypename , groups = myEnemyGroups , friendlygroups = myFriendlyGroups, startpoint=myStartPoint }
			
	-- doInstructPlayers ( {group=input.group} )
	doInstructPlayers ( {group=input.group} )
	
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
	
	
end 
--- MISSION ROTARY ---
function mission_TroopInsertion ( input )
	removeActiveMissions ( {group=input.group , } )
	local myEnemyGroups = {}
	local myFriendlyGroups = {}
	local myDistanceBetweenForces = 1000
	local myDistanceFromObjective = 18000
	local myFlightTimeBetweenForces = 1 -- in minutes
	local myDriveTimeBetweenForces = 1 -- in minutes
	local myUnitEnemyCounts = 3
	local myGroupEnemyCounts = 1
	local myUnitFriendlyCounts = 10
	local myGroupFriendlyCounts = 4
	local myFriendlyUnitSpaced = 3
	local myEnemyUnitSpaced = 10
	local myFriendlyGroupSpaced = 5
	local myEnemyGroupSpaced = 10

	local mySurfaceWater = {[1]="Water" ,} 
	local mySurfaceLand = {[1]="Land" ,} 
	local mySurfaceMixed = {[1]="Water" ,[2]="Land" ,}
	-- GET PLAYER AIRCRAFT TYPE INFORMATION
	input.enterservice = gPlayerGroups[input.group].enterservice
	input.retired = gPlayerGroups[input.group].retired
	input.country = gPlayerGroups[input.group].historicalcountry
	input.accurate = gPlayerGroups[input.group].preferences.historicalaccurate
	input.playerspeed = Targets[gPlayerGroups[input.group].key].speed*.75
	local myLanguage = gPlayerGroups[input.group].preferences.language
	
	-- OUR TARGET TYPES GROUND
	input.medium=MissionCombat.TROOPS.combat -- TARGET TYPES
	local myFriendlyCategory = MissionCombat.TROOPS
	local myEnemyCategory = MissionCombat.ARTILLERY
	local myEnemySpawnType=Group.Category.GROUND
	local myFriendlySpawnType=Group.Category.GROUND
	input.action = "On Road"
	local myFriendlyCountry = Targets[gPlayerGroups[input.group].key].country -- FRIENDLY WILL END UP BEING OPPOSING SIDE OF PLAYERS
	
	-- GET A ENEMY TARGET TYPE
	input.country = Targets[gPlayerGroups[input.group].key].country
	
	input.mission = myEnemyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET 
	local myEnemyTargets=myTargets[math.random( 1, #myTargets )] 
	myEnemyTargets.key = string.upper(myEnemyTargets.type:gsub('[%p%c%s]', '') )
	
	local myEnemyPayload = {}
	if myEnemySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myEnemyPayload  = {  ["fuel"] = myEnemyTargets.fuel , ["pylons"] = myEnemyTargets.pylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 } 
		if myEnemyTargets.enterservice <= 1958 then 
			myEnemyPayload.flare = 0 
			myEnemyPayload.chaff = 0 
		end 
	end
	
	-- CHANGE GET A FRIENDLY TARGET TYPE 
	input.country = myFriendlyCountry -- country is opposite of enemy for both to be opposite of group ( ships , etc )
	--input.country = Targets[myEnemyTargets.key].country --friendly is same country as human group aircraft type
	
	--GET A FRIENDLY TARGET TYPE 
	input.mission = myFriendlyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET
	local myFriendlyTargets=myTargets[math.random( 1, #myTargets )] 
	myFriendlyTargets.key = string.upper(myFriendlyTargets.type:gsub('[%p%c%s]', '') )
	local myFriendlyPayload = {}
	if myFriendlySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myFriendlyPayload  = {  ["fuel"] = myFriendlyTargets.fuel , ["pylons"] = myFriendlyTargets.gpylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 }
		if myEnemyTargets.enterservice <= 1958 then 
			myEnemyPayload.flare = 0 
			myEnemyPayload.chaff = 0 
		end 
	end 	

	-- CHANGE FIND CLOSEST FRIENDLY AIRPORT
	input.alt = 0
	local myTypename = input.menu
	local myUnitName = Unit.getName(Group.getByName(input.group):getUnit(1))
	local myPosition = centerUnitCoordinates (myUnitName)
	local myEnemyAirport = findClosestAirbase ({position=myPosition ,coalition=input.friendlycoa })
	
	local myRunway = getPointOnRadian ( { diameter=30 , pos=myEnemyAirport.point , angle = myEnemyAirport.angle+math.pi/2 })
	if land.getSurfaceType( {x=myRunway.x , y=myRunway.z } ) == 5 then 
		myRunway = getPointOnRadian ( { diameter=30 , pos=myEnemyAirport.point , angle = myEnemyAirport.angle-math.pi/2 })
	end 
	local myFriendlyPosition = getPointOnRadian ( { diameter=300 , pos= myRunway , angle = myEnemyAirport.angle })
	--local myFriendlyDisembark = getPointOnRadian ( { diameter=4000 , pos=myEnemyAirport.point , angle = myEnemyAirport.angle })
	
	local myRandomDistance = gPlayerGroups[input.group].preferences.targetrange + (math.random ( 2 , 5 )*1000)
	--local myRandomDistance = 6000 --gPlayerGroups[input.group].preferences.targetrange + (math.random ( 2 , 5 )*1000)
	local myEnemyRandom = findMatchingSurfacePoints ( {unit=Unit.getName(Group.getByName(input.group):getUnit(1)) ,surfacetypes={[1]="Land" ,}, distance=myRandomDistance , samples=12, precision=100 } )
	myEnemyRandom.position.x, myEnemyRandom.position.z = land.getClosestPointOnRoads('roads' , myEnemyRandom.position.x, myEnemyRandom.position.z )
	
	local myEnemyRandomStart = findMatchingSurfacePoints ( {position=myEnemyRandom.position ,surfacetypes={[1]="Land" ,}, distance=myDistanceBetweenForces*2 , samples=12, precision=100 } )
	myEnemyRandomStart.position.x, myEnemyRandomStart.position.z = land.getClosestPointOnRoads('roads' , myEnemyRandomStart.position.x, myEnemyRandomStart.position.z )
	myEnemyRandomStart.position.x, myEnemyRandomStart.position.z = land.getClosestPointOnRoads('roads' , myEnemyAirport.point.x, myEnemyAirport.point.z )

	
	--- BACK
	local myEnemyRoute = {}
	local myMaxDistance = 1000 -- meters away
	local myRunningTotal = 0 
	local myCountem = 0

	myEnemyRoute = land.findPathOnRoads("roads", myEnemyRandom.position.x , myEnemyRandom.position.z , myEnemyRandomStart.position.x, myEnemyRandomStart.position.z )



	local myRoadLength = getDistanceBetweenTwoPoints( {x=myEnemyRoute[1].x , z=myEnemyRoute[1].y } , {x=myEnemyRoute[#myEnemyRoute].x , z=myEnemyRoute[#myEnemyRoute].y } )
	if myRoadLength > myDistanceBetweenForces then -- THE ROAD PROB GOES THROUGH

		while ( myMaxDistance >= myRunningTotal) do
			myCountem = myCountem + 1
			local myDistance = getDistanceBetweenTwoPoints( {x=myEnemyRoute[myCountem].x , z=myEnemyRoute[myCountem].y } , {x=myEnemyRoute[myCountem+1].x , z=myEnemyRoute[myCountem+1].y } )
			myRunningTotal = myRunningTotal + myDistance
			if ( myCountem > 1000 )  or ( myCountem == #myEnemyRoute) then myRunningTotal = myMaxDistance*2 end 
		end 
		myEnemyRandomStart.position = myEnemyRandom.position
		myEnemyRandom.position = {x=myEnemyRoute[myCountem].x , z=myEnemyRoute[myCountem].y}
	end 
	
	
	
	-- local myEnemyPosition = getPointOnRadian ( { diameter=myDistanceBetweenForces , pos=myFriendlyDisembark , angle = myEnemyAirport.angle })
	local myFriendlyDisembark = getPointOnRadian ( { diameter=100 , pos=myEnemyRandom.position , angle=getAngleBetweenTwoPoints(myEnemyRandom.position , myEnemyAirport.point) })
	local myPathfinderPosition = getPointOnRadian ( { diameter=20 , pos=myFriendlyDisembark , angle=math.random(1,6) })
	myEnemyPosition = myEnemyRandom.position
	-- trigger.action.smoke(myFriendlyDisembark, 1 )
	local myFriendlyWaypoint = myFriendlyPosition
	local myEmbarkingTask =  	{
                                                        [1] = 
                                                        {
                                                            ["number"] = 1,
                                                            ["auto"] = false,
                                                            ["id"] = "EmbarkToTransport",
                                                            ["enabled"] = true,
                                                            ["params"] = 
                                                            {
                                                                ["y"] = myFriendlyPosition.z ,
                                                                ["x"] = myFriendlyPosition.x,
                                                                ["zoneRadius"] = 2000,
                                                            }, -- end of ["params"]
                                                        } 
								}
	local myDisEmbarkingTask =  {
                                                        [1] = 
                                                        {
                                                            ["number"] = 1,
                                                            ["auto"] = false,
                                                            ["id"] = "DisembarkFromTransport",
                                                            ["enabled"] = true,
                                                            ["params"] = 
                                                            {
                                                                ["y"] = myFriendlyDisembark.z ,
                                                                ["x"] = myFriendlyDisembark.x,
                                                                ["zoneRadius"] = 2000,
                                                            }, -- end of ["params"]
                                                        } 
								}
	local myExtractionTask =  	{
                                                        [1] = 
                                                        {
                                                            ["number"] = 1,
                                                            ["auto"] = false,
                                                            ["id"] = "EmbarkToTransport",
                                                            ["enabled"] = true,
                                                            ["params"] = 
                                                            {
                                                                ["y"] = myFriendlyDisembark.z ,
                                                                ["x"] = myFriendlyDisembark.x,
                                                                ["zoneRadius"] = 2000,
                                                            }, -- end of ["params"]
                                                        } 
								}
 

	-- CHANGE WHICH WAY ARE FORCES HEADING
	local myHeadingEnemy = getBearingTwoPoints(myEnemyPosition , myFriendlyPosition )
	local myHeadingFriendly = getBearingTwoPoints(  myFriendlyPosition, myEnemyPosition )
	local myStartPoint = myFriendlyPosition -- POSITION TO DIRECT THE PLAYER TO FLY TOWARDS
	gTargetsCount = gTargetsCount + 1
--- CREATE THE ENEMY TARGET
	for groups = 1, myGroupEnemyCounts do
		local myEnemyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyGroupSpaced) , pos=myEnemyRandomStart.position , angle = math.random(1,6) })
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = input.action, pos=myFriendlyPosition , alt = myEnemyAlt  , altType="RADIO" , speed = myEnemyTargets.speed , }
		local myUnits = {}
		for units = 1, myUnitEnemyCounts do
			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyUnitSpaced) , pos=myEnemyGroupPosition , angle = math.random(1,6) })
			myUnits[#myUnits+1] = { name = "E" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading=myHeadingEnemy,  spawn_type=myEnemySpawnType , skill = gEnemySkillLevel  , type=myEnemyTargets.type, position=myUnitPosition  , alt=myEnemyAlt , speed=0, altType="RADIO", }
			if myEnemySpawnType == Group.Category.AIRPLANE or myEnemySpawnType == Group.Category.HELICOPTER then myUnits[#myUnits].payload = myEnemyPayload  end
		end
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = input.action , pos=myEnemyPosition , alt = myEnemyAlt  , altType="RADIO" , speed =myEnemyTargets.speed , }
		myWaypoints[#myWaypoints+1] = { action = input.action , pos=myEnemyAirport.point , alt = myEnemyAlt  , altType="RADIO" , speed =myEnemyTargets.speed , }
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name="E" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gEnemySkillLevel , action= input.action , waypoints=myWaypoints, lateActivation=true , spawn_type=myEnemySpawnType , type=myEnemyTargets.type, position=myEnemyGroupPosition , heading=myHeadingEnemy, country=input.enemycountry , speed=myEnemyTargets.speed , alt=myEnemyAlt , altType="RADIO", tasks=myEnemyTask,}
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.enemycountryid, myEnemySpawnType, myBuiltSpawn ) 
		myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true} --friendly in the group triggers enemy not players  
	end 				
	
	-- CREATE THE FRIENDLY TARGET
	for groups = 1, myGroupFriendlyCounts do
		local myFriendlyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyGroupSpaced)*groups , pos=myFriendlyPosition , angle = myEnemyAirport.angle })
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = input.action , pos=myFriendlyGroupPosition , alt = myFriendlyAlt  , altType="RADIO" , speed =myFriendlyTargets.speed , task=myEmbarkingTask }
		myWaypoints[#myWaypoints+1] = { action = input.action , pos=myFriendlyDisembark , alt = myFriendlyAlt  , altType="RADIO" , speed =myFriendlyTargets.speed , } -- task=myDisEmbarkingTask }
		myWaypoints[#myWaypoints+1] = { action = input.action , pos=myFriendlyDisembark , alt = myFriendlyAlt  , altType="RADIO" , speed =myFriendlyTargets.speed , }
	--	myWaypoints[#myWaypoints+1] = { action = input.action , pos=myFriendlyDisembark , alt = myFriendlyAlt  , altType="RADIO" , speed =myFriendlyTargets.speed , task=myExtractionTask }
		
		local myUnits = {}
		for units = 1, myUnitFriendlyCounts do
			local myType = Targets.SOLDIERM249.type
			if units <= ( myUnitFriendlyCounts/2 ) or units == 1 then myType=Targets.SOLDIERRPG.type end 
			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyUnitSpaced) , pos=myFriendlyGroupPosition , angle = math.random(1,6) })
			myUnits[#myUnits+1] = { name = "F" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading = myHeadingFriendly , spawn_type=myFriendlySpawnType, skill = gFriendlySkillLevel  , type=myType, position=myUnitPosition  , alt=myFriendlyAlt , speed=myEnemyTargets.speed, altType="RADIO", }
			if myFriendlySpawnType==Group.Category.AIRPLANE or myFriendlySpawnType == Group.Category.HELICOPTER then 
				myUnits[#myUnits].payload = myFriendlyPayload 		
			end
		end
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name="F" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gFriendlySkillLevel , action= "Off Road" , waypoints=myWaypoints, lateActivation=true , spawn_type=myFriendlySpawnType, type=myFriendlyTargets.type, position=myFriendlyGroupPosition , heading=myHeadingFriendly , country=input.friendlycountry , speed=myFriendlyTargets.speed , alt=myFriendlyAlt , altType="RADIO", tasks=myFriendlyTask, }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.friendlycountryid, myFriendlySpawnType , myBuiltSpawn )
		myFriendlyGroups[#myFriendlyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
	end	
	-- CREATE THE PATHFINDER
	local myWaypoints={}
	myWaypoints[#myWaypoints+1] = { action = input.action , pos=myFriendlyDisembark , alt = myFriendlyAlt  , altType="RADIO" , speed =myFriendlyTargets.speed , task=myExtractionTask }
	
	gCurrentGroupID = gCurrentGroupID + 1
	local mySpawn = { name="FP" .. gTargetsCount .. "G1"  , groupID=gCurrentGroupID, skill=gFriendlySkillLevel , action= "Off Road" , lateActivation=true , spawn_type=myFriendlySpawnType, type="Paratrooper AKS-74" , position=myFriendlyDisembark , heading=0 , country=input.friendlycountry , speed=0 , alt=myFriendlyAlt , altType="RADIO", } 
	local myBuiltSpawn = doBuildSpawn (mySpawn)
	coalition.addGroup(input.friendlycountryid, myFriendlySpawnType , myBuiltSpawn )
	--myFriendlyGroups[#myFriendlyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
	local myFriendlyPathfinder = {[1] ={name=mySpawn.name , type=mySpawn.type ,  }, }
	local myEndpoint = myFriendlyDisembark
	local myTargetName = "Enemy " ..  gTargetsCount
	local myHiddenGroups = {}
	--local myFriendlyTriggers = {}
	local myEnemyTriggers = {}
	
	-- WANT THEM ALL TO SPAWN AT SAME TIME PUT IN HIDDEN GROUPS
	for key , value in pairs(myFriendlyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
	end
	for key , value in pairs(myFriendlyPathfinder) do
		myHiddenGroups[#myHiddenGroups+1] = value
	end

	
	local myPlayerGroups = {[1]={name=input.group,type=gPlayerGroups[input.group].type}}
	local myMessages =	{[1]="pickuptroops" , [2]="flyheading", [3]="inserttroops", [4]="protect_friendy"}
	local myTriggers = {[1]={groups=myPlayerGroups, atgroup=myFriendlyGroups[1].name} , -- group near atgroup or atpoint
						[2]={groups=myPlayerGroups, atpoint=myFriendlyDisembark, stayhidden=true, effects={smoke={position=myFriendlyDisembark,color=1},}},
						[3]={groups=myFriendlyGroups, atgroup=myEnemyGroups[1].name , directto=myFriendlyPathfinder } , 
						[4]={groups=myPlayerGroups, atgroup=myFriendlyGroups[1].name } ,
						}

	local myHiddenTargets = {[1]=myFriendlyGroups  , [2]=myFriendlyPathfinder , [3]=myEnemyGroups ,}
	--myFriendlyGroups[#myFriendlyGroups+1] = myFriendlyPathfinder[1] -- put the pathfinder group into friendly groups for cleanup
	gTargets[input.group] = { name=input.group, target=myTargetName , groups=myEnemyGroups, friendlygroups=myHiddenGroups , startpoint=myStartPoint,  activated=false ,  menu=input.menu, 
	typename=myTypename, key=myEnemyTargets.key,  missiontype=gSayThis[myLanguage].destroy_enemy , 
	triggers=myTriggers, messages=myMessages , phrasecount=1}
	
	gHiddenTargets[input.group] = { name=input.group,  groups=myHiddenTargets , triggers=myTriggers , menu=input.menu }
	
	-- gLocationTriggers[input.group] = { name=input.group, triggers=myLocationTriggers ) 
	
	gMissionsRunning[input.group] = { name=input.group, friendlycountry=input.friendlycountry , friendlycountryid=input.friendlycountryid, group=input.group,  menu=input.menu , typename=myTypename , groups = myEnemyGroups , friendlygroups = myHiddenGroups, startpoint=myStartPoint, endpoint=myEndpoint,}
			
	-- doInstructPlayers ( {group=input.group} )
	doInstructPlayers ( {group=input.group} )
	
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
	
	
end 
function mission_TroopInsertionDestroyed ( input )
	local myEndpoint = gMissionsRunning[input.group].endpoint
	for key , value in pairs(gMissionsRunning[input.group].friendlygroups) do
		local EmbarkToTransport = { id = "EmbarkToTransport",  params = {  x = myEndpoint.x , y = myEndpoint.z, zoneRadius = 1000}}
		ResetGroupController ( value.name ) 
		SendOptionToGroup ( value.name , AI.Option.Ground.id.ALARM_STATE,  1) 	
		SendControlToGroup ( value.name , EmbarkToTransport , true )		
	end 
	
	local myFriendlyGroups = gMissionsRunning[input.group].friendlygroups
	local myText = gSayThis["English"].extracttroops
	-- gSayThis["English"].extracttroops
    -- gSayThis["English"].flyheading
	--doPrintThis ({clearview = gClearView  , group=input.name, duration= 30 , text=myText })
	local myCoa = coalition.getCountryCoalition(gMissionsRunning[input.group].friendlycountryid )
	local myFriendlyAirbase = findClosestAirbase ({position=gMissionsRunning[input.group].endpoint ,coalition=myCoa })
	local myPlayerGroups = {[1]={name=input.group,type=gPlayerGroups[input.group].type}}
	
	local myMessages =	{[1]="extracttroops" , [2]="missioncompleted" }
	local myTriggers = {[1]={groups=myPlayerGroups, atpoint=myFriendlyAirbase.point, endmission=true } , -- group near atgroup or atpoint
						}
	local myMenu = gMissionsRunning[input.group].menu
	local myHiddenTargets = {[1]=myFriendlyGroups ,}

	gTargets[input.group] = { name=input.group, target=myTargetName , groups=myFriendlyGroups, friendlygroups=myFriendlyGroups , startpoint=myFriendlyAirbase.point,  activated=true ,  menu=myMenu , 
	typename=myFriendlyAirbase.name, key="OUTPOST" , returntoairbase=myFriendlyAirbase.name , triggers=myTriggers, messages=myMessages , phrasecount=1}
	
	gHiddenTargets[input.group] = { name=input.group,  groups=myHiddenTargets , triggers=myTriggers , menu=myMenu }
	
	doInstructPlayers ( {group=input.group} )
	
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
	gMissionsRunning[input.group] = nil
end
function mission_TroopExtraction ( input )
	removeActiveMissions ( {group=input.group , } )
	local myEnemyGroups = {}
	local myFriendlyGroups = {}
	local myUnitEnemyCounts = 10
	local myGroupEnemyCounts = 1
	local myUnitFriendlyCounts = 5
	local myGroupFriendlyCounts = 1

	-- FIND CLOSEST ENEMY AIRPORT
	local myUnitName = Unit.getName(Group.getByName(input.group):getUnit(1))
	local myPosition = centerUnitCoordinates (myUnitName)

	local myFriendlyAirport = findClosestAirbase ({position=myPosition , coalition=input.friendlycoa })
	local myLanguage = gPlayerGroups[input.group].preferences.language
	local myRandomDistance = gPlayerGroups[input.group].preferences.targetrange + (math.random ( 3 , 10 )*1000)
	--local myRandomDistance = 6000 --gPlayerGroups[input.group].preferences.targetrange + (math.random ( 2 , 5 )*1000)
	local myEnemyPosition = getPointOnRadian ( { diameter=myRandomDistance , pos=myPosition  , angle=math.random(1,6) } )
	myEnemyPosition.x, myEnemyPosition.z = land.getClosestPointOnRoads('roads' , myEnemyPosition.x, myEnemyPosition.z ) -- FIND A CLOSE ROAD TO ENDPOINT

	myFriendlyPosition = getPointOnRadian ( { diameter=3000 , pos=myEnemyPosition , angle = math.random(1,6)})
	myFriendlyPosition = findMatchingSurfacePoints ( {position=myFriendlyPosition ,surfacetypes={[1]="Land" ,}, distance=3000 , samples=15, precision=100 } )
	myFriendlyPosition.position.x, myFriendlyPosition.position.z = land.getClosestPointOnRoads('roads' , myFriendlyPosition.position.x, myFriendlyPosition.position.z )
	--myFriendlyPosition.position = getPointOnRadian ( { diameter=20 , pos=myFriendlyPosition.position , angle = math.random(1,6)})
	
	-- CREATE THE ENEMY TARGET
	input.medium=MissionCombat.ANTIAIR.combat
	input.mission=MissionCombat.ANTIAIR
	input.category=CombatCategory.Ground 
	input.enterservice = gPlayerGroups[input.group].enterservice
	input.retired = gPlayerGroups[input.group].retired
	input.country = gPlayerGroups[input.group].country
	
	--CREATE THE ENEMY INFANTRY	
	local myEnemyInfantryPosition = getPointOnRadian ( { diameter=getDistanceBetweenTwoPoints( myFriendlyPosition.position, myEnemyPosition )*.75, pos=myEnemyPosition , angle = getAngleBetweenTwoPointsV2(myEnemyPosition , myFriendlyPosition.position)  })
	--myEnemyInfantryPosition = findMatchingSurfacePoints ( {position=myEnemyInfantryPosition ,surfacetypes={[1]="Land" ,}, distance=500 , samples=15, precision=100 } )
	gTargetsCount = gTargetsCount + 1
	for squads = 1,myGroupEnemyCounts do

		local myUnits = {}
		local myEnemySquadPosition = getPointOnRadian ( { diameter=(math.random(2,4)*10) , pos=myEnemyInfantryPosition , angle = math.random(1,6) })
		
		for i=1,myUnitEnemyCounts do
			myUnits[#myUnits+1] = { name = "EI" .. gTargetsCount .."G" .. squads .. "U" .. i  , heading = math.random(1,6) , spawn_type=Group.Category.GROUND , skill = gEnemySkillLevel , type=InfantryTargets.INFANTRYAK.type, position=myEnemySquadPosition  , speed=10, altType="RADIO", }
			myUnitsPostion = getPointOnRadian ( { diameter=math.random(2,10) , pos=myEnemySquadPosition , angle = math.random(1,6) })
			myEnemySquadPosition = getPointOnRadian ( { diameter=(math.random(2,4)*10) , pos=myEnemySquadPosition , angle = math.random(1,6) })
		end
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = "Off Road", pos=myFriendlyPosition.position, alt = 0  , altType="RADIO" , speed =5 , }
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "EI" .. gTargetsCount .."G" .. squads , groupID=gCurrentGroupID, skill=gEnemySkillLevel , units=myUnits, action= "Off Road" , waypoints=myWaypoints, lateActivation=true , spawn_type=Group.Category.GROUND , type=InfantryTargets.SOLDIERAK.type, position=myEnemyPosition , heading=3.14 , country=input.enemycountry , speed=10  , altType="RADIO", }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.enemycountryid, Group.Category.GROUND, myBuiltSpawn ) 
		myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
	
	end
	
	-- CREATE THE ENEMY MORTARS
	local myMortarPosition = getPointOnRadian ( { diameter=500 , pos=myEnemyPosition, angle = math.random(1,6) })
	local myMortarTargetZone = getPointOnRadian ( { diameter=500 , pos=myFriendlyPosition.position , angle = math.random(1,6) })
	local myAngleToTarget = getAngleBetweenTwoPointsV2(myMortarPosition , myFriendlyPosition.position)
	local myTask =   {	[1] = {["number"] = 1,["auto"] = false,["id"] = "FireAtPoint",["enabled"] = true,["params"] = {
						["y"] = myMortarTargetZone.z,
						["expendQty"] = 1000,
						["expendQtyEnabled"] = false,
						["x"] = myMortarTargetZone.x,
						["templateId"] = "",
						["weaponType"] = 1073741822,
						["zoneRadius"] = 1000,
						}, -- end of ["params"]
						}, -- end of [1]
						} -- end of ["tasks"]
	for i = 1,1 do
		myMortarPosition = getPointOnRadian ( { diameter=20 , pos=myEnemyPosition , angle = i  })
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "EM" .. gTargetsCount .."G" .. i  , groupID=gCurrentGroupID, skill=gEnemySkillLevel , lateActivation=true , action= "Off Road" , spawn_type=Group.Category.GROUND , type=InfantryTargets["2B11MORTAR"].type, position=myMortarPosition, heading=myAngleToTarget , country=friendlycountry , speed=0 , alt=0 , altType="RADIO", tasks=myTask, }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
			--deReference ( mySpawn )
		coalition.addGroup(input.enemycountryid, Group.Category.GROUND, myBuiltSpawn )
		myEnemyGroups[#myEnemyGroups+i] = {name=mySpawn.name , type=mySpawn.type ,  }					
	end	

	-- CREATE THE ENEMY RESUPPLY
	local myWaypoints = {}
	myWaypoints[#myWaypoints+1] = { action = "Off Road", pos=myEnemyPosition, alt = 0  , altType="RADIO" , speed =0 }
	
	gCurrentGroupID = gCurrentGroupID + 1
	local mySpawn = { name = "ET" .. gTargetsCount .."G1" , groupID=gCurrentGroupID, skill=gEnemySkillLevel , lateActivation=true , waypoints=myWaypoints , action= "Off Road" , spawn_type=Group.Category.GROUND , type=Targets.URAL375.type, position=myEnemyPosition , heading=math.random(1,6) , country=friendlycountry , speed=0 , alt=0 , altType="RADIO",	tasks=myTask, }
	local myBuiltSpawn = doBuildSpawn (mySpawn)
	coalition.addGroup(input.enemycountryid, Group.Category.GROUND, myBuiltSpawn ) 
	myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }	
		
	-- CREATE THE FRIENDLY RESCUE
	local myTerrainTemp = getPointOnRadian ( { diameter=100 , pos=myFriendlyPosition.position , angle = math.random(1,6) })
	local myEmbarkingTask =  {
                                                        [1] = 
                                                        {
                                                            ["number"] = 1,
                                                            ["auto"] = false,
                                                            ["id"] = "EmbarkToTransport",
                                                            ["enabled"] = true,
                                                            ["params"] = 
                                                            {
                                                                ["y"] = myTerrainTemp.z ,
                                                                ["x"] = myTerrainTemp.x,
                                                                ["zoneRadius"] = 2000,
                                                            }, -- end of ["params"]
                                                        } 
								}
	local myWaypoints={}
	
	myWaypoints[#myWaypoints+1] = { action = "Off Road", pos=myTerrainTemp, alt = 0  , altType="RADIO" , speed = 10, task=myEmbarkingTask }
	local myUnitsPostion = getPointOnRadian ( { diameter=math.random(2,10) , pos=myTerrainTemp , angle = math.random(1,6) })
	for squads = 1,myGroupFriendlyCounts do
		local myUnits = {}
		for i=1,myUnitFriendlyCounts do
			myUnits[#myUnits+1] = { name = "FI" .. gTargetsCount .."G" .. squads .. "U".. i  , heading = math.random(1,6) , spawn_type=Group.Category.GROUND , skill = gFriendlySkillLevel , type=InfantryTargets.INFANTRYAK.type, position=myUnitsPostion , alt=0 , speed=10, altType="RADIO", }
			myUnitsPostion = getPointOnRadian ( { diameter=math.random(2,10) , pos=myTerrainTemp , angle = math.random(1,6) })
		end
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "FI" .. gTargetsCount .."G" .. squads , groupID=gCurrentGroupID, units=myUnits, skill=gFriendlySkillLevel, action= "Off Road" , lateActivation=true , waypoints=myWaypoints, spawn_type=Group.Category.GROUND , type=InfantryTargets.INFANTRYAK.type, position=myFriendlyPosition.position , heading=3.14 , country=input.friendlycountry , speed=10 , alt=0 , altType="RADIO", }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.friendlycountryid, Group.Category.GROUND, myBuiltSpawn )
		myFriendlyGroups[#myFriendlyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
	end
	
	-- CREATE THE DROPOFF TRUCK
	local myWaypoints={}
	myWaypoints[#myWaypoints+1] = { action = input.action , pos=myFriendlyAirport.point , alt = 0  , altType="RADIO" , speed =0 , }
	
	gCurrentGroupID = gCurrentGroupID + 1
	local mySpawn = { name="FP" .. gTargetsCount .. "G1"  , groupID=gCurrentGroupID, skill=gFriendlySkillLevel , action= "Off Road" , lateActivation=true , spawn_type=Group.Category.GROUND, type=Targets.URAL375.type , position=myFriendlyAirport.point , heading=0 , country=input.friendlycountry , speed=0 , alt=0 , altType="RADIO", } 
	local myBuiltSpawn = doBuildSpawn (mySpawn)
	coalition.addGroup(input.friendlycountryid, Group.Category.GROUND , myBuiltSpawn )
	--myFriendlyGroups[#myFriendlyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
	local myFriendlyDropoff = {[1] ={name=mySpawn.name , type=mySpawn.type ,  }, }

			
	--local myTargetName = "Enemy " ..  gTargetsCount
	local myTargetKey = string.upper(Targets.OUTPOST.type:gsub('[%p%c%s]', '') )

	
	local myHiddenGroups = {}
	for key , value in pairs(myEnemyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
	end
	for key , value in pairs(myFriendlyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
	end
	
	local myTypename = input.menu 
	local myMissionType = gSayThis[myLanguage].destroy_enemy .. " " .. gSayThis[myLanguage].sayand
	
	local myPlayerGroups = {[1]={name=input.group,type=gPlayerGroups[input.group].type}}
	local myMessages =	{[1]="flyheading" ,[2]="extracttroops",}
	local myTriggers = {[1]={groups=myPlayerGroups, atgroup=myFriendlyGroups[1].name} ,  -- group near atgroup or atpoint
						[2]={groups=myPlayerGroups, atpoint=myFriendlyAirport.point , endmission=true} ,
						}

	local myHiddenTargets = {[1]=myHiddenGroups , [2]=myFriendlyDropoff }


	gTargets[input.group] = { name=input.group, target=myTargetName , groups=myEnemyGroups, friendlygroups=myFriendlyGroups , 
	startpoint=myEnemyInfantryPosition, activated=false ,  menu=input.menu, typename=myTypename, key=myTargetKey ,  missiontype=myMissionType, 
	triggers=myTriggers, messages=myMessages , phrasecount=1, }
	
	gHiddenTargets[input.group] = { name=input.group, groups=myHiddenTargets ,triggers=myTriggers,  menu=input.menu}
	gMissionsRunning[input.group] = { name=input.group, group=input.group, groups = myHiddenGroups ,  menu=input.menu , typename=myTypename  , startpoint = myEnemyPosition  }

	-- doInstructPlayers ( {group=input.group} )
	doInstructPlayers ( {group=input.group} )
	
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
	
end 


function RandomSpawnPoints ( input ) -- TOOLBOX ROUTINE
				local myWrongSurface = "Water"
				local myLand = myWrongSurface
				local myCountem = 1
				local myPoint = {}
				local myDistance = input.distance + (math.random(1,5)* input.variance)
				local myGroup = input.groupname  --.. myCountem .. " " .. n
				local myAngle = 1
				while ( myLand == myWrongSurface) do		 -- FIND A SPOT ONLY ON LAND
					myCountem = myCountem + 1
					if myCountem > 10 then -- more than 10 tries to get land?  increase the distance
						myDistance = myDistance + 5000
						myCountem = 1
					end
					myAngle = (math.pi*2)/12 * math.random(1,12)
					myPoint  = getPointOnRadian ( { diameter=myDistance , pos=input.position , angle = myAngle  })
					
					myLand = getSurfaceTypePoint( myPoint )
				end
				
				if input.notsurface ~= nil then
					local myHoldPoint = {x=myPoint.x , z=myPoint.z } 
					myWrongSurface = input.notsurface
					myLand = myWrongSurface
					myCountem = 1
					myDistance = 0
					while ( myLand == myWrongSurface) do
						myCountem = myCountem + 1
						if myCountem > 10 then -- more than 10 tries to get land?  increase the distance
							myDistance = myDistance + 500
							myCountem = 1
						end
			
						myPoint  = getPointOnRadian ( { diameter=myDistance , pos=myHoldPoint , angle = myAngle })
						myLand = land.getSurfaceType{x = myPoint.x, y = myPoint.z}
						if myLand == myWrongSurface then
							-- if Debugging == true then  printDebug ( "EventHandler" ,  "On Runway"  , 10 ) end
						end 
						myDistance = myDistance + 100
					end
				end 
		
		return myPoint
		-- end
end

--- MISSIONS CLONER --
function mission_GenericSpawn_TargetsDestroyed ( input ) 
	returnToBaseDirections ( {group=input.group} )
end 
function mission_GenericSpawn ( input )
	removeActiveMissions ( {group=input.group , } )
	gTargetsCount = gTargetsCount + 1
	local myEnemyGroups = {}
	local myFriendlyGroups = {}
	local myDistanceBetweenForces = 3000
	local myDistanceFromObjective = 18000
	local myFlightTimeBetweenForces = 1 -- in minutes
	local myDriveTimeBetweenForces = 1 -- in minutes
	local myUnitEnemyCounts = 3
	local myGroupEnemyCounts = 1
	local myUnitFriendlyCounts = 4
	local myGroupFriendlyCounts = 1
	local myFriendlyUnitSpaced = 200
	local myEnemyUnitSpaced = 200
	local myFriendlyGroupSpaced = 500
	local myEnemyGroupSpaced = 500

	local mySurfaceWater = {[1]="Water" ,} 
	local mySurfaceLand = {[1]="Land" ,} 
	local mySurfaceMixed = {[1]="Water" ,[2]="Land" ,}
	-- GET PLAYER AIRCRAFT TYPE INFORMATION
	input.enterservice = gPlayerGroups[input.group].enterservice
	input.retired = gPlayerGroups[input.group].retired
	input.country = gPlayerGroups[input.group].historicalcountry
	input.accurate = gPlayerGroups[input.group].preferences.historicalaccurate
	input.playerspeed = Targets[gPlayerGroups[input.group].key].speed*.75
	local myLanguage = gPlayerGroups[input.group].preferences.language
	
	-- OUR TARGET TYPES SHIPPING
	input.medium=MissionCombat.SUBMARINE.combat -- TARGET TYPES
	local myFriendlyCategory = MissionCombat.CARGOSHIP
	local myEnemyCategory = MissionCombat.SUBMARINE
	local myEnemySpawnType=Group.Category.SHIP
	local myFriendlySpawnType=Group.Category.SHIP
	input.action = "Turning Point"
	local myFriendlyCountry = Targets[gPlayerGroups[input.group].key].country -- FRIENDLY WILL END UP BEING OPPOSING SIDE OF PLAYERS



	-- CHANGE OUR TARGET TYPES AIRBORNE
	-- local myFriendlyCategory = MissionCombat.BOMBER
	-- local myEnemyCategory = MissionCombat.FIGHTER
	-- local myEnemySpawnType=Group.Category.AIRPLANE
	-- local myFriendlySpawnType=Group.Category.AIRPLANE
	-- input.action = "Turning Point"
	-- myFriendlyCountry = Targets[gPlayerGroups[input.group].key].country -- FRIENDLY WILL END UP BEING OPPOSING SIDE OF ENEMY
	
	-- GET A ENEMY TARGET TYPE
	input.country = Targets[gPlayerGroups[input.group].key].country
	
	input.mission = myEnemyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET 
	local myEnemyTargets=myTargets[math.random( 1, #myTargets )] 
	myEnemyTargets.key = string.upper(myEnemyTargets.type:gsub('[%p%c%s]', '') )
	
	local myEnemyPayload = {}
	if myEnemySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myEnemyPayload  = {  ["fuel"] = myEnemyTargets.fuel , ["pylons"] = myEnemyTargets.pylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 } 
		if myEnemyTargets.enterservice <= 1958 then 
			myEnemyPayload.flare = 0 
			myEnemyPayload.chaff = 0 
		end 
	end
	
	-- CHANGE GET A FRIENDLY TARGET TYPE 
	input.country = myFriendlyCountry -- country is opposite of enemy for both to be opposite of group ( ships , etc )
	--input.country = Targets[myEnemyTargets.key].country --friendly is same country as human group aircraft type
	
	--GET A FRIENDLY TARGET TYPE 
	input.mission = myFriendlyCategory
	local myTargets = checkTargetTables (input) -- LOOK FOR A TARGET
	local myFriendlyTargets=myTargets[math.random( 1, #myTargets )] 
	myFriendlyTargets.key = string.upper(myFriendlyTargets.type:gsub('[%p%c%s]', '') )
	local myFriendlyPayload = {}
	if myFriendlySpawnType == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		myFriendlyPayload  = {  ["fuel"] = myFriendlyTargets.fuel , ["pylons"] = myFriendlyTargets.gpylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 }
		if myFriendlyTargets.enterservice <= 1958 then 
			myFriendlyPayload.flare = 0 
			myFriendlyPayload.chaff = 0 
		end 
	end 	

	-- CHANGE FIND CLOSEST ENEMY AIRPORT
	-- input.alt = 0
	-- local myTypename = myFriendlyTargets.category .. " " .. input.menu
	-- local myUnitName = Unit.getName(Group.getByName(input.group):getUnit(1))
	-- local myPosition = centerUnitCoordinates (myUnitName)
	-- local myEnemyAirport = findClosestAirbase ({position=myPosition ,coalition=input.friendlycoa })
	-- local myEnemyPosition = getPointOnRadian ( { diameter=myDistanceBetweenForces , pos=myEnemyAirport.point , angle = myEnemyAirport.angle+math.pi })
	-- local myFriendlyPosition = getPointOnRadian ( { diameter=0 , pos=myEnemyAirport.point , angle = myEnemyAirport.angle })
	-- local myFriendlyWaypoint = myEnemyPosition
	
	-- CHANGE FIND THE CLOSEST WATER TARGET
	input.alt = 0
	local myTypename = myFriendlyTargets.category .. " " .. input.menu
	local myFriendlyAlt = 0
	local myEnemyAlt = 0
	local myPrecision = 1000 -- how big the water and land must be to decide on it
	local myFriendlyGroupSpaced = 1000
	local myEnemyGroupSpaced = 1000
	local myFriendlyUnitSpaced = 1000
	local myEnemyUnitSpaced = 1000
	myDistanceBetweenForces = ((input.playerspeed/3600)*(myFlightTimeBetweenForces*120))*MILES_TO_METERS
	--local myGroupPosition = centerUnitCoordinates (Unit.getName(Group.getByName(input.group):getUnit(1))) -- GET THE POSITION OF WHOEVER IS NUMBER 1
	local myRandomDistance = gPlayerGroups[input.group].preferences.targetrange + (math.random ( 3 , 10 )*1000)
	local myStartingPosition = findMatchingSurfacePoints ( {unit=Unit.getName(Group.getByName(input.group):getUnit(1)) ,surfacetypes=mySurfaceWater, distance=myRandomDistance , samples=12, precision=myPrecision } )
	local myEndingPosition = findMatchingSurfacePoints ( {position=myStartingPosition.position ,surfacetypes=mySurfaceWater, distance=myDistanceBetweenForces , samples=15, precision=myPrecision } )
	local myEnemyPosition = myStartingPosition.position -- MAKE IS SIMPLIER BECAUSE WE RETURN A TABLE
	local myFriendlyPosition = myEndingPosition.position -- MAKE IS SIMPLIER BECAUSE WE RETURN A TABLE
	local myFriendlyWaypoint = myEnemyPosition

	
	--CHANGE FIND THE CLOSEST AIRBORNE TARGET
	-- local myTypename = 	myFriendlyTargets.type .. " " .. input.menu
	-- local myPrecision = 50 -- how big the water and land must be to decide on it
	-- myDistanceBetweenForces = ((myEnemyTargets.speed/3600)*(myFlightTimeBetweenForces*60))*MILES_TO_METERS
	-- local myPlayersAlt = GetAltitudeRangesGroup ( { group=input.group, } )
	-- local myFriendlyAlt = myPlayersAlt.average_msl + math.random (5,10)*1000
	-- local myEnemyAlt = myFriendlyAlt -- + math.random (2,4)*1000
	-- local myFriendlyAngle = math.random(1,6)
	-- local myEnemyAngle = myFriendlyAngle+(math.pi/2) - (math.random(0,5)*(math.pi/5))
	-- local myEnemyAirport = findClosestAirbase ({position=centerUnitCoordinates (Unit.getName(Group.getByName(input.group):getUnit(1))) ,coalition=input.enemycoa })
	-- local myFriendlyPosition = getPointOnRadian ( { diameter=myDistanceFromObjective*2 , pos=myEnemyAirport.point , angle=myFriendlyAngle })
	-- local mFriendlyAirport = findClosestAirbase ({position=myEnemyAirport.point ,coalition=input.friendlycoa })
	-- local myFriendlyWaypoint = mFriendlyAirport.point
	-- local myEnemyPosition = getPointOnRadian ( { diameter=myDistanceBetweenForces , pos=myEnemyAirport.point  , angle = myEnemyAngle })
	-- local myBombingPoint = {x=myEnemyAirport.point.x , y=myEnemyAirport.point.z} 
	-- local myEnemyTask = formation.WWIIFighterOpen -- formation always comes first in task list or will crash game
	-- myEnemyTask[2] = {["number"] = 2,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargets', params = { maxDistEnabled = true, maxDist = 100000 ,targetTypes = {[1] = "All",}, noTargetTypes = {}, priority = 0 , } }
	-- local myFriendlyTask =	formation.WWIIBomberTight -- formation always comes first in task list or will crash game
	-- myFriendlyTask[2] = {["number"] = 2,["auto"] = false,["id"] = 'CarpetBombing', params = {  point = myBombingPoint, attackQtyLimit = false, attackType = "Carpet", weaponType = 2147485694 , expend = "All", attackQty = 1, groupAttack = true, altitude = myFriendlyAlt*FEET_TO_METERS, altitudeEnabled = true, } } 
	


	-- CHANGE WHICH WAY ARE FORCES HEADING
	local myHeadingEnemy = getBearingTwoPoints(myEnemyPosition , myFriendlyPosition )
	local myHeadingFriendly = getBearingTwoPoints(  myFriendlyPosition, myEnemyPosition )
	local myStartPoint = myFriendlyPosition -- POSITION TO DIRECT THE PLAYER TO FLY TOWARDS

--- CREATE THE ENEMY TARGET
	for groups = 1, myGroupEnemyCounts do
		local myEnemyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyGroupSpaced) , pos=myEnemyPosition , angle = math.random(1,6) })
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = input.action, pos=myFriendlyPosition , alt = myEnemyAlt  , altType="RADIO" , speed = myEnemyTargets.speed , }
		local myUnits = {}
		for units = 1, myUnitEnemyCounts do
			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myEnemyUnitSpaced) , pos=myEnemyGroupPosition , angle = math.random(1,6) })
			myUnits[#myUnits+1] = { name = "E" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading=myHeadingEnemy,  spawn_type=myEnemySpawnType , skill = gEnemySkillLevel  , type=myEnemyTargets.type, position=myUnitPosition  , alt=myEnemyAlt , speed=myEnemyTargets.speed, altType="RADIO", }
			if myEnemySpawnType == Group.Category.AIRPLANE or myEnemySpawnType == Group.Category.HELICOPTER then myUnits[#myUnits].payload = myEnemyPayload  end
		end

		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "E" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gEnemySkillLevel , action= input.action , waypoints=myWaypoints, lateActivation=true , spawn_type=myEnemySpawnType , type=myEnemyTargets.type, position=myEnemyGroupPosition , heading=myHeadingEnemy, country=input.enemycountry , speed=myEnemyTargets.speed , alt=myEnemyAlt , altType="RADIO", tasks=myEnemyTask,}
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.enemycountryid, myEnemySpawnType, myBuiltSpawn ) 
		myEnemyGroups[#myEnemyGroups+1] = {name=mySpawn.name , type=mySpawn.type , friendlytrigger=true} --friendly in the group triggers enemy not players  
	end 				
	
	-- CREATE THE FRIENDLY TARGET
	for groups = 1, myGroupFriendlyCounts do
		local myFriendlyGroupPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyGroupSpaced) , pos=myFriendlyPosition , angle = math.random(1,6) })
		local myWaypoints={}
		myWaypoints[#myWaypoints+1] = { action = input.action , pos=myFriendlyWaypoint , alt = myFriendlyAlt  , altType="RADIO" , speed =myFriendlyTargets.speed ,  }
		local myUnits = {}
		for units = 1, myUnitFriendlyCounts do
			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(2,4)*myFriendlyUnitSpaced) , pos=myFriendlyGroupPosition , angle = math.random(1,6) })
			myUnits[#myUnits+1] = { name = "F" .. gTargetsCount .. "G" .. groups .. "U" .. units  , heading = myHeadingFriendly , spawn_type=myFriendlySpawnType, skill = gFriendlySkillLevel  , type=myFriendlyTargets.type, position=myUnitPosition  , alt=myFriendlyAlt , speed=myFriendlyTargets.speed, altType="RADIO", }
			if myFriendlySpawnType==Group.Category.AIRPLANE or myFriendlySpawnType == Group.Category.HELICOPTER then 
				myUnits[#myUnits].payload = myFriendlyPayload 		
			end
		end
		
		gCurrentGroupID = gCurrentGroupID + 1
		local mySpawn = { name = "F" .. gTargetsCount .. "G" .. groups , groupID=gCurrentGroupID, units=myUnits, skill=gFriendlySkillLevel , action= input.action , waypoints=myWaypoints, lateActivation=true , spawn_type=myFriendlySpawnType, type=myFriendlyTargets.type, position=myFriendlyGroupPosition , heading=myHeadingFriendly , country=input.friendlycountry , speed=myFriendlyTargets.speed , alt=myFriendlyAlt , altType="RADIO", tasks=myFriendlyTask, }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		coalition.addGroup(input.friendlycountryid, myFriendlySpawnType , myBuiltSpawn )
		myFriendlyGroups[#myFriendlyGroups+1] = {name=mySpawn.name , type=mySpawn.type ,  }
	end	

	local myTargetName = "Enemy " ..  gTargetsCount
	local myHiddenGroups = {}
	--local myFriendlyTriggers = {}
	local myEnemyTriggers = {}
	
	-- WANT THEM ALL TO SPAWN AT SAME TIME PUT IN HIDDEN GROUPS
	for key , value in pairs(myEnemyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
	--	myEnemyTriggers[#myEnemyTriggers+1] = value
	end
	for key , value in pairs(myFriendlyGroups) do
		myHiddenGroups[#myHiddenGroups+1] = value
	--	myFriendlyTriggers[#myFriendlyTriggers+1] = value
	end
	
	local myPlayerGroups = {[1]={name=input.group,type=gPlayerGroups[input.group].type}}
	local myMessages =	{[1]="flyheading" , [2]="searcharea", [3]="clearedtofire",}
	local myTriggers = {[1]={groups=myPlayerGroups, atgroup=myFriendlyGroups[1].name} , -- group near atgroup or atpoint
						[2]={groups=myPlayerGroups, atgroup=myEnemyGroups[1].name},
						[3]={groups=myPlayerGroups, atgroup=myEnemyGroups[1].name} , 
						}

	local myHiddenTargets = {[1]=myFriendlyGroups , [2]=myEnemyGroups ,}
	
	gTargets[input.group] = { name=input.group, target=myTargetName , groups=myEnemyGroups, friendlygroups=myFriendlyGroups , startpoint=myStartPoint, activated=false ,  menu=input.menu, 
	typename=myTypename, key=myEnemyTargets.key,  missiontype=gSayThis[myLanguage].destroy_enemy , 
	triggers=myTriggers, messages=myMessages , phrasecount=1}
	
	gHiddenTargets[input.group] = { name=input.group,  groups=myHiddenTargets , triggers=myTriggers , menu=input.menu }
	
	-- gLocationTriggers[input.group] = { name=input.group, triggers=myLocationTriggers ) 
	
	gMissionsRunning[input.group] = { name=input.group, friendlycountry=input.friendlycountry , friendlycountryid=input.friendlycountryid, group=input.group,  menu=input.menu , typename=myTypename , groups = myEnemyGroups , friendlygroups = myFriendlyGroups, startpoint=myStartPoint }
			
	-- doInstructPlayers ( {group=input.group} )
	doInstructPlayers ( {group=input.group} )
	
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
	
end 


if onetime == nil then
	gCurrentGroupID = 10000
	loadLanguages ()
	if gLanguage == nil then gLanguage="English" end 
	if gDifficulty == nil then gDifficulty="normal" end 
	if gFlightRange == nil then gFlightRange="medium" end
	if gDetectRange == nil then gDetectRange="far" end
	if gUnitsOfMeasure == nil then gUnitsOfMeasure="feet" end
	if gTargetRange == nil then gTargetRange = { short = 10000 , medium=20000 , long=40000 , far=90000 ,} end
	if gTargetDetectRange == nil then gTargetDetectRange = { short = 5000 , medium=10000 , long=20000 ,far=40000 ,} end
	if gAllowWindSock == nil then gAllowWindSock = true end
	if gTargetDestroyDelay == nil then gTargetDestroyDelay = math.huge end
	if gEnemySkillLevel == nil then gEnemySkillLevel="Random" end 
	if gFriendlySkillLevel == nil then gFriendlySkillLevel="Random" end
	if gHistoricalFoes == nil then gHistoricalFoes = "Accurate" end
	if gJumpedPercent == nil then gJumpedPercent = 0 end
	if gTargetsExpire == nil then gTargetsExpire = true end
	if gSaveGroupDefaults == nil then gSaveGroupDefaults = false end
	if gWWIIAssets == nil then gWWIIAssets = false end
	
	 -- in seconds to destroy target after last member leaves group
	gDifficultySettings = { normal = 1 , hard=2 , challenging=3,}  

	
	gGroupPreferences = {} 
	onetime = true
	gSquad = { members={} , joinorder={} , difficulty=gDifficultySettings.normal }
	gPlayers = { }
	gPlayerGroups = {}
	gTargets = {} -- for holding the active target or mission
	gTankers = {}
	gTankerFreqeuncy = 128.5
	gVisibleTargets = {}
	gIntradiction = {}
	gTargetsCount = 0 -- HOW MANY TOTAL TARGETS IN THE MISSION
	gEventLoopTimer = 10 -- IN SECONDS FOR EVENT LOOP TO HAPPEN
	gBlueCountries = {[1]="USA" ,[2]="UK", [3]="GERMANY", }
	gRedCountries = {[1]="RUSSIA", [2]="USSR", [3]="THIRDREICH", }
	gMissionMenu = {  "Combat"  , "Training" }
	gLanguageTypes = { [1]= "English" ,  [2] = "English2" , [2] = "Spanish" }
	gMissionsActive = true -- ACTIVATE MISSIONS MENU
	gAirborneTargetAlt =  { min=3 , max=6 } --FLGHT LEVELS FOR RANDOM SPAWNING ALT
	gUnmaskDistance = 100000
	gOrphanedTime = 6000 -- how long orphaned targets stay active 

	local myBluePlayers = coalition.getPlayers(coalition.side.BLUE )
	local myRedPlayers = coalition.getPlayers(coalition.side.RED )
	if #myBluePlayers > 0 or #myRedPlayers > 0 then
		local myPlayerUnit = world.getPlayer( )
		insertPlayerIntoMission ( {unit=Unit.getName(myPlayerUnit )} )
	end 

	local gVersion = "b.1.0 ( Feb 2021 )"
	local gWelcomeText = "Welcome to Fixed Base of Operations for Multi-Player version " .. gVersion  .. "\nUse the Radio Menu to get started (\\ Key). Then 'F10: Options' to select mission options." 
	gMap = gMaps.caucasus
	
	if Airbase.getByName("McCarran International Airport" ) ~= nil then gMap = gMaps.nevada end
	if Airbase.getByName("Havadarya" ) ~= nil then gMap = gMaps.persian end                                                               
	if Airbase.getByName("Carpiquet" ) ~= nil then gMap = gMaps.normandy end                                                              
	if Airbase.getByName("Manston" ) ~= nil then gMap = gMaps.channel end                                                                 
	if Airbase.getByName("Abu al-Duhur" ) ~= nil then gMap = gMaps.syrian end                                                             
                                                                                                                                                                                                                                                             
	local myText = gWelcomeText -- .. "Your FBO is " .. myAirbase.name .. "(" .. SpawnAirbase ..") on the " ..gMap .. " Map " .. gVersion     
	doPrintThis ({duration= 30 , text=myText }) 
	
end 





--assert(loadfile("C:\\Users\\brad\\Saved Games\\DCS\\Missions\\toolbox\\globalobjects.lua"))() 
--assert(loadfile("C:\\Users\\brad\\Saved Games\\DCS\\Missions\\toolbox\\toolbox.lua"))() 
--assert(loadfile("C:\\Users\\brad\\Saved Games\\DCS\\Missions\\Multiplayer FBO\\onetime.lua"))()
--assert(loadfile("C:\\Users\\brad\\Saved Games\\DCS\\Missions\\Multiplayer FBO\\events.lua"))() 
--assert(loadfile("C:\\Users\\brad\\Saved Games\\DCS\\Missions\\Multiplayer FBO\\missions.lua"))()  
--assert(loadfile("C:\\Users\\brad\\Saved Games\\DCS\\Missions\\Multiplayer FBO\\devevents.lua"))() 